		

;*************************************************************************************
;Codi destinat a controlar un receptor GPS Conexant TU30
;per mitja de 2 pulsadors es va mostrant la diferent informaci
;Autor: Christian Schindler Vasquez
;data: 
;*************************************************************************************




;Directives necesaries per el compilador
;treiem la protecci de copia, el watchdog,active el Power-up Timer Enable i
;finalment indiquem que la senyal de clock vindr donada per un oscilador de
;cristall
	__CONFIG   _CP_OFF &  _WDT_OFF & _PWRTE_ON & _XT_OSC

;El pic que farem servir es un 16F876
	LIST	   P=16F876

;Afegim les llibreries necesaries
	INCLUDE  <P16F876.INC>
	INCLUDE <MACROS.INC>

;Definim uns alias per els ports que utilitzarem, son directives per tant no generen codi
#DEFINE WR     PORTC,3
#DEFINE R_D    PORTC,2
#DEFINE C_D    PORTC,1
#DEFINE RESET  PORTC,0
#DEFINE C_E    PORTA,2
#DEFINE pulsador   PORTC,5
#DEFINE pulsador2   PORTC,4


;Declarem el nom de la variable i indiquem a on estar guardada dins la nostra memoria de dades
	estat_anterior EQU 0x21
	dada_rebuda EQU 0x22
	comptador_hora EQU 0x23
	hora2 EQU 0x24
	hora1 EQU 0x25
	minut2 EQU 0x26
	minut1 EQU 0x27
	segon2 EQU 0x28
	segon1 EQU 0x29
	posicio_valida EQU 0x2A
	coordenada1_deg2 EQU 0x2B
	coordenada1_deg1 EQU 0x2C
	coordenada1_min7 EQU 0x2D
	coordenada1_min6 EQU 0x2E
	coordenada1_min5 EQU 0x2F
	coordenada1_min4 EQU 0x30
	coordenada1_min3 EQU 0x31
	coordenada1_min2 EQU 0x32
	coordenada1_min1 EQU 0x33
	comptador_coordenada1 EQU 0x34
	N_o_S EQU 0x35
	coordenada2_deg3 EQU 0x36
	coordenada2_deg2 EQU 0x37
	coordenada2_deg1 EQU 0x38
	coordenada2_min7 EQU 0x39
	coordenada2_min6 EQU 0x3A
	coordenada2_min5 EQU 0x3B
	coordenada2_min4 EQU 0x3C
	coordenada2_min3 EQU 0x3D
	coordenada2_min2 EQU 0x3E
	coordenada2_min1 EQU 0x40
    comptador_coordenada2 EQU 0x41
    E_o_W EQU 0x42
    velocitat1 EQU 0x43
    velocitat2 EQU 0x44
    velocitat3 EQU 0x45
    velocitat4 EQU 0x46
    velocitat5 EQU 0x47
	velocitat6 EQU 0x48
    comptador_velocitat EQU 0x49
	TEMP equ 0x4A
	proba equ 0x4B
	primer_cop equ 0x4C
	RET2 equ 0x4D
	RET3 equ 0x4E
	RET1 equ 0x4F
	comptador_direccio equ 0x50
	direccio1 equ 0x51
	direccio2 equ 0x52
	direccio3 equ 0x53
	direccio4 equ 0x54
	direccio5 equ 0x55
	es_coma equ 0x56
	ContA equ 0x57
	ContB equ 0x58
	pantalla equ 0x59
	pantalla_temp equ 0x5A
	hora_borrada equ 0x5B
	coordenada1_borrada equ 0x5C
	coordenada2_borrada equ 0x5D
	velocitat_borrada equ 0x5E
	direccio_borrada equ 0x5F
	validesa_borrada equ 0x60
	data_borrada equ 0x61
	num_satelits_borrats equ 0x62
	N_o_S_borrada equ 0x63
	E_o_W_borrada equ 0x64
	comptador_data equ 0x65
	data1 equ 0x66
	data2 equ 0x67
	data3 equ 0x68
	data4 equ 0x69
	data5 equ 0x6A
	data6 equ 0x6B
; apretat1 controla els rebots,
	apretat1 equ 0x6C
	satelit2 equ 0x6D
	satelit1 equ 0x6E
	altura1 equ 0x6F

	PCLATH_TEMP equ 0x70
	STATUS_TEMP equ 0x71
	W_TEMP equ 0x72


	altura2 equ 0x73
	altura3 equ 0x74
	altura4 equ 0x75
	altura5 equ 0x76
	altura6 equ 0x77
	comptador_altura equ 0x78
	altura_borrada equ 0x79
	kilometres_apretat equ 0x7A
	km equ 0x7B

;A partir d'aqui per falta d'espai continuem en un altre banc de memoria
;el banc 01
	id11 equ 0xA0
	id12 equ 0xA1
	id21 equ 0xA2
	id22 equ 0xA3
	id31 equ 0xA4
	id32 equ 0xA5
	id41 equ 0xA6
	id42 equ 0xA7
	id51 equ 0xA8
	id52 equ 0xA9
	id61 equ 0xAA
	id62 equ 0xAB
	id71 equ 0xAC
	id72 equ 0xAD
	id81 equ 0xAE
	id82 equ 0xAF
	id91 equ 0xB0
	id92 equ 0xB1
	id101 equ 0xB2
	id102 equ 0xB3
	id111 equ 0xB4
	id112 equ 0xB5
	id121 equ 0xB6
	id122 equ 0xB7
	senyal1 equ 0xB8
	senyal2 equ 0xB9
	senyal3 equ 0xBA 
	senyal4 equ 0xBB
	senyal5 equ 0xBC
	senyal6 equ 0xBD
	senyal7 equ 0xBE
	senyal8 equ 0xBF
	senyal9 equ 0xC0
	senyal10 equ 0xC1
	senyal11 equ 0xC2
	senyal12 equ 0xC3
	part equ 0xC4
	punter_sat_nivells equ 0xC5
	variable_pag2 equ 0xC7
	proba2 equ 0xC8
	valor_sat_nivells equ 0xC9
	nivells_borrats equ 0xCA
	NUM equ 0xCB
	DEN equ 0xCC
	resultat equ 0xCD
	centenes equ 0xCE
	desenes equ 0xCF
	unitats equ 0xD0
	vel_temp1 equ 0xD1
	vel_temp2 equ 0xD2
	vel_temp3 equ 0xD3
	vel_temp4 equ 0xD4
	vel_temp5 equ 0xD5
	vel_temp6 equ 0xD6
	vel_temp7 equ 0xD7
	vel_temp0 equ 0xD8
	vel_temp8 equ 0xD9
	carry_anterior equ 0xDA
	vel_previa1 equ 0xDB
	vel_previa2 equ 0xDC
	vel_previa3 equ 0xDD
	vel_previa4 equ 0xDE
	vel_previa5 equ 0xDF
	vel_previa6 equ 0xE0
	vel_previa7 equ 0xE1
	coma_temp equ 0xE2
	coma_temp_no_final equ 0xE3
	coma_vel equ 0xE4
	coma_vel_no_final equ 0xE5
	TEMP1 equ 0xE6
	TEMP2 equ 0xE7
	W_TEMP2 equ 0xE8
	STATUS_TEMP2 equ 0xE9
	PCLATH_TEMP2 equ 0xEA
	vel_previa0 equ 0xEB
	ADDR equ 0xEC
	valor1 equ 0xED
	valor2 equ 0xEE
	resultat_bcd equ 0xEF

;Grabem les dades a la eeprom, per el canvi d'hora,
;cada parella de numero equival a un any,que va fins el 2010
;de cada parella el primer dia simbolitza el quin dia del mar cal canviar 
;l'hora i la seva parella fa el mateix per l'ocutbre.
    ORG 02100h ; Direccin del Banco EEPROM
        DE 0x25
        DE 0x28
        DE 0x30
        DE 0x26
        DE 0x29
        DE 0x25
        DE 0x28
        DE 0x31

; Aqui comencem a programar dins la memoria de codi, comencem a l'inici de la pgina 00 i saltem cap a l'inici del codi
	ORG 	0		
	goto Inicio
; En cas d'haver rebut alguna interrupci vindrem aqui i saltem cap a l'inici del codi
	ORG 0x04 
	goto Inter
  
;coloquem aqui les nostres subrutines

;Posa a 0 els leds  
apagar_tots
	bcf PORTA,0
	bcf PORTA,1
return
    

;l'Status_check es una comprobaci que fem per saber si l'LCD esta llest per
;rebre noves dades. Es tracta de comprobar si STA0 i STA1 estan a 1. Aquesta paraula
;d'estat la rebem pel portB, activant RD->L CE->L WR->H C/D->H
status_check
;Canviem de Bank i posem el portB com a entrada
	bsf STATUS,RP0
	movlw 0xFF
	movwf TRISB
;Tornem al banc 0
	bcf STATUS,RP0
;Activem les senyals
	bsf WR
	bsf C_D
	bcf R_D
	bcf C_E
refresca	
	nop
	nop 
	;llegim STA0 i STA1
	btfss PORTB,0
	goto refresca
	btfss PORTB,1
	goto refresca
	nop
	nop
	nop
	;cambiem el valors dels senyals de control
	bsf C_E
	bcf C_D
	;tornem a configurar PORTB com a sortida
	bsf STATUS,RP0
	clrf TRISB
	bcf STATUS,RP0
return


;Envia una dada pel portB
envia_dada
	call status_check
;Per enviar una dada s'han de tenir activat WR=L, C/D=L
	bsf C_D
	bsf R_D
	bsf WR
;coloquem la dada que tenim a W al port B
	movf TEMP,w
	movwf PORTB
;activem la escriptura
	bcf WR
	bcf C_D
	bcf C_E
	nop 
	nop
	nop
	nop
	bsf WR
	bsf C_D
	bsf C_E
return

;Per fer reset es mant el pin de reset a nivell baix durant uns pocs nanosegons
;tenim en compte que la velocitat del micro amb el xtall de 4Mhz es de l'ordre de
; 1 microsegon/instruccio
fer_reset 
	bsf RESET
	nop
	bcf RESET
	nop
	nop
	nop
	nop
	bsf RESET
return

;Per enviar una comanda activarem aquests senyals de control WR=L i C/D=H
envia_comanda
	call status_check
	bsf C_D
	bsf WR
	bsf R_D
;movem la dada al portB
	movf TEMP,w
	movwf PORTB
;activem l'escriptura de comanda
	bcf WR
	bcf C_E
	nop
	nop
	nop
	nop
	nop
	nop
	bsf WR
	bsf C_E
return

;Aqui es tracta de dir-li al LCD on comena la part de memoria RAM que utilitzarem		
;En aquest cas volem l'area de TEXT i comena a la 1000H
adressa_inicial
	call status_check
;coloquem al registre TEMP la part baixa de l'adressa
	movlw 0x00
	movwf TEMP
	call envia_dada
	call status_check
;coloquem la part alta
;en el codi '51 diu q posem un 0*****************************************************************************************************************
	movlw 0x00
	movwf TEMP
	call envia_dada
;li enviem la comanda que ens indica que hem enviat la adressa inicial
	movlw 0x40
	movwf TEMP
	call envia_comanda
	call status_check
return

;Aqui li diem quants bytes desprs de la adrea inicial ocupara el mapa de memoria de la nostra 
;pantalla. Es sol posar el numero de columnes, cada caracter ocupa 8x8 pixels, l'LCD cont
;240x64 pixels, el que ens dona 30columnes x 8 files. 30d=1Eh
area_text
	call status_check
	;en el codi '51 diu de posar-hi un 14
	movlw 0x1E
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0x00
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0x41
	movwf TEMP
	call envia_comanda
	call status_check
return

;Inicialitzem l'LCD
init 
	;mode AND(pag 18/46, datasheet Toshiba T6963C)
	call status_check
	movlw 0x81
	movwf TEMP
	call envia_comanda
	call status_check
	;cursor de dos linies(pag 20/46,datasheet Toshiba T6963C)
	movlw 0xA0
	movwf TEMP
	call envia_comanda
	call status_check
	;Activa cursor, parpalleig,text display, i desactiva graphic display
	;Datasheet dmf5000, apartat 5.2.2.4
	movlw 0x94
	movwf TEMP
	call envia_comanda
	call status_check
return

;aquesta subrutina es bsica, coloca el punter a la posici que troba a la 
;variable punter_sat_nivells.
punter
	call status_check
	banksel punter_sat_nivells
	movfw punter_sat_nivells
	banksel TEMP
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0x00
	banksel TEMP
	movwf TEMP
	call envia_dada
	call status_check
	banksel TEMP
	movlw 0x24
	movwf TEMP
	call envia_comanda
	call status_check
return

;Coloca el punter al inici i escriu el caracter blanc per tot l'LCD.
neteja_pantalla	
	movlw d'240'
	movwf proba
Bucle	
	call status_check
	movlw 0x00
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	decfsz proba,1
	goto Bucle
return

;Escriu per pantalla "SISTEMA GPS"
escriu_Presentacio
	call status_check
	movlw 0x33
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x29
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x33
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x34
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x25
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x2D
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x21
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x00
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x27
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x30
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x33
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
return


;Escriu a l'lcd   "Coordenada:"
escriu_Coor
	call status_check
	movlw 0x23
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x4F
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda

	call status_check
	movlw 0x4F
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda

	call status_check
	movlw 0x52
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda

	call status_check
	movlw 0x44
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda

	call status_check
	movlw 0x45
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda

	call status_check
	movlw 0x4E
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda

	call status_check
	movlw 0x41
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda

	call status_check
	movlw 0x44
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda

	call status_check
	movlw 0x41
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x1A
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda	
return


;Escriu al LCD 'N' o 'S' depenen del valor
;de la variable N_o_S
escriu_N_o_S
	call status_check
	movf N_o_S,w
	xorlw 0x4E ;mira si es la lletra 'N'
	btfsc STATUS, Z
	goto escriu_S
	call status_check
	movlw  0x2E ;escriu la lletra 'N' en l'ASCII usat en l'LCD
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
escriu_S	
	movlw  0x33;escriu la lletra 'S' en l'ASCII usat en l'LCD
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda	
return
	
;Escriu al LCD 'E' o 'O' depenen del valor
;de la variable E_o_W	
escriu_E_o_W
	call status_check
	movf E_o_W,w
	xorlw 0x45 ;mira si es la lletra 'E'
	btfsc STATUS, Z
	goto escriu_w
	call status_check
	movlw  0x25  ;escriu la lletra 'E' en l'ASCII usat en l'LCD
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
escriu_w	
	movlw  0x37 ;escriu la lletra 'O' en l'ASCII usat en l'LCD
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
return



;aquestes subrutines on el nom acaba amb la subrutina _buida escriuen
;la mateixa cantitad de caracters que el seu equivalent sense "_buida"
;pero escribint carcters en blanc. Aix s necesari perqu quan passem
;de pantalla la informaci que no ha d'apareixer desparegui.
escriu_coordenada1_buida	
	movlw d'23'
	movwf proba
Bucle_coordenada1	
	call status_check
	movlw 0x00
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	decfsz proba,1
	goto Bucle_coordenada1	
return

escriu_NS_EW_buida	
	movlw d'1'
	movwf proba
Bucle_mag	
	call status_check
	movlw 0x00
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	decfsz proba,1
	goto Bucle_mag	
return

escriu_hora_buida
	movlw d'8'
	movwf proba
Bucle_hora	
	call status_check
	movlw 0x00
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	decfsz proba,1
	goto Bucle_hora	
return


;Escriu a l'lcd el valor de les variables entremig de punts
;hora2 hora1 : minut2 minut1 : segon2 segon1
escriu_hora
	call status_check
	movf hora2,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda	
	
	call status_check
	movf hora1,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda	
	
	call status_check
	movlw 0x1A
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movf minut2,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda	
	
	call status_check
	movf minut1,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda	
	
	call status_check
	movlw 0x1A
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movf segon2,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda	
	
	call status_check
	movf segon1,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda	
return


;Escriu a l'LCD les seguents variables amb una coma entremig
; coordenada1_deg2 coordenada1_deg1 coordenada1_min7 coordenada1_min6 , coordenada1_min5 coordenada1_min4
; coordenada1_min3 coordenada1_min2 coordenada1_min1
escriu_coordenada1

	call status_check
	movf coordenada1_deg2,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movf coordenada1_deg1,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda

	call status_check
	movf coordenada1_min7,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda

	call status_check
	movf coordenada1_min6,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x0E
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movf coordenada1_min4,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movf coordenada1_min3,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movf coordenada1_min2,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movf coordenada1_min1,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP  
	call envia_comanda	
return

;Escriu a l'LCD les seguents variables amb una coma entremig
; coordenada2_deg2 coordenada2_deg1 coordenada2_min7 coordenada2_min6 , coordenada2_min5 coordenada2_min4
; coordenada2_min3 coordenada2_min2 coordenada2_min1
escriu_coordenada2_buida
	movlw d'11'
	movwf proba
Bucle_coordenada2	
	call status_check
	movlw 0x00
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	decfsz proba,1
	goto Bucle_coordenada2	
return


;Escriu a l'LCD les seguents variables amb una coma entremig
; coordenada1_deg2 coordenada1_deg1 coordenada1_min7 coordenada1_min6 , coordenada1_min5 coordenada1_min4
; coordenada1_min3 coordenada1_min2 coordenada1_min1
escriu_coordenada2
	call status_check
	movf coordenada2_deg3,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movf coordenada2_deg2,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movf coordenada2_deg1,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda

	call status_check
	movf coordenada2_min7,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda

	call status_check
	movf coordenada2_min6,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x0E
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movf coordenada2_min4,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movf coordenada2_min3,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movf coordenada2_min2,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movf coordenada2_min1,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
return

;Posa a en blanc els caracters de escriu_dadaNoValida
escriu_dadaNoValida_buida
	movlw d'20'
	movwf proba
Bucle_validesa	
	call status_check
	movlw 0x00
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	decfsz proba,1
	goto Bucle_validesa
return

;Escriu a LCD "Dades NO vlides"
escriu_dadaNoValida
	call status_check
	movlw 0x24
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x41
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda

	call status_check
	movlw 0x44
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x45
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x53
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x00
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x2E
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x2F
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x00
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x56
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x65
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x4C
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x49
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x44
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	
	call status_check
	movlw 0x45
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda	

	call status_check
	movlw 0x53
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0xC0
	movwf TEMP
	call envia_comanda
return

;Tenim un rutina de retard que utilitzarem per mostrar durant uns 2 segons
;el retol de presentaci del programa que es mostra al engegar el sistema
retard 
	movlw d'10'
	movwf RET2
	movlw d'254'
	movwf RET3
primerBucle	
	decfsz RET2,F
	goto segonBucle
	goto continua3
segonBucle
	call retard1milis
	decfsz RET3,F
	goto segonBucle
	goto continua2
continua2
	goto primerBucle
continua3
return
	
retard1milis
	movlw d'249'
	movwf RET1
r1
	nop
	decfsz RET1,F
	goto r1
return 



;Aqui comena el codi que executar el PIC quan s'engegui
Inicio
	;***********inicialitzem el LCD**********************
; Accs al Bank 1
	bsf	STATUS,RP0
	bcf STATUS,RP1
;Els ports A i B es declaren com a sortida
	clrf	TRISA			
	clrf	TRISB		
;El port C tindr com entrada el port serie i els 2 pulsadors
	movlw b'10110000'
 	movwf TRISC
	bcf	STATUS,RP0		; Access al Bank 0.
;inicialitzem tots els ports a 0
	clrf PORTA
	clrf PORTB
	clrf PORTC
;Posem a 1 CE
	bsf PORTA,2
;fem un reset al LCD
	call fer_reset
;indicar l'inici de la memoria de Text a RAM
	call adressa_inicial	
;numero de bytes on s'haura d'extendre la zona de RAM
	call area_text

;inicialitzacio de diverses coses
	call init
;Creem el smbol que utilitzarem per mostrar les 
;barres de nivell.
;A la documentacio es mostra com es s'ha de crear
;un smbol

	call status_check
	movlw 0x03
	banksel TEMP
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0x00
	banksel TEMP
	movwf TEMP
	call envia_dada
	call status_check
	movlw 0x22
	banksel TEMP
	movwf TEMP
	call envia_comanda
	call status_check
	
;posem el punter al seu lloc...

	call status_check
	banksel TEMP
	movlw 0x00
	movwf TEMP
	call envia_dada
	call status_check
	banksel TEMP
	movlw 0x1C
	movwf TEMP
	call envia_dada
	call status_check
	banksel TEMP
	movlw 0x24
	movwf TEMP
	call envia_comanda
	call status_check

;posem a 0 el comptador
	clrf proba

;i dibuixem els simbols
lletra
	call status_check
	banksel TEMP
	movfw 0x3C
	movwf TEMP
	call envia_dada
	call status_check
	banksel TEMP
	movlw 0xC0
	movwf TEMP
	call envia_comanda
	call status_check

	movfw proba
	addlw .1
	movwf proba
	xorlw .8
	btfss STATUS,Z
	goto lletra


;;**** per borrar!!


;************************************


;coloquem el punter referent al desplaament
	movlw .0
;la directiva banksel ens colloca al banc de dades on es trobi
;la variable que l'indiquem
;Netejem la pantalla
	banksel punter_sat_nivells
	movwf punter_sat_nivells
	call punter
	call neteja_pantalla
;Mostrem la presentaci
	movlw .70
	banksel punter_sat_nivells
	movwf punter_sat_nivells
	call punter
	call escriu_Presentacio
	call retard
;netjem la pantalla
	movlw .0
	banksel punter_sat_nivells
	movwf punter_sat_nivells
	call punter
	call neteja_pantalla



;********************  Inicialitzem el GPS  *******************
;Ens posem al bank 1
		bsf	STATUS,RP0	
		bcf	STATUS,RP1
;Habilitem l'interrupcio de Recepcio
		bsf PIE1,RCIE			
;Configurem la USART i activem la transmissio
		movlw	b'00000100'	
		movwf	TXSTA	
		movlw	.51
		movwf	SPBRG
;Ens posem al bank0
		bcf	STATUS,RP0	
;Posem la USART amb recepcci continua
		movlw b'10010000' 
		movwf RCSTA
;Habilitem les interrupcions en general
		movlw b'11000000'		
	    movwf INTCON
;Activem la USART
		bsf	RCSTA,SPEN


; *********************  Inicialitzem el Timer1  ***************
;Parem el timer
  		 movlw 0x00
 		 movwf T1CON
;Posem a 0 els valors de recarga
   		clrf TMR1L
  		clrf TMR1H
;Netejem el flag
 		bcf   PIR1,0
;Activem la interrupci del timer1
   		bsf   STATUS,RP0     
   		bsf PIE1,0
;Activem el tiemr1
   		bcf   STATUS,RP0     
   		bsf T1CON,0 

;********************  Inicialitzem valors  ********************
       	clrf  estat_anterior
        clrf  comptador_hora
        clrf  comptador_coordenada1
        clrf  comptador_coordenada2
        clrf  comptador_velocitat
    	clrf  comptador_data
        clrf  primer_cop
        clrf  comptador_direccio
		clrf  apretat1
		clrf  apretat1
		clrf  kilometres_apretat
		clrf  comptador_altura
		banksel part
		clrf  part
		clrf  variable_pag2
		banksel pantalla
		movlw 0x10
		movwf  pantalla
		clrf  km
   		call  apagar_tots	


;Aquest ser el nostre bucle principal 
;Noms ha d'anar comprobant que no hi hagi un solapament
;de dades en el buffer cosa que aturaria la USART i
;atenent les interrupcions que succeixin
Principal   
bcf PIE1,RCIE
		btfsc RCSTA,1
		goto arrecla_serie2
		goto Principal
arrecla_serie2
		bcf RCSTA,4
		bsf RCSTA,4
bsf PIE1,RCIE
goto 	Principal	




;**********************************************************
;**********************************************************
;**********************************************************
;*************                          *******************
;*************   RUTINA D'INTERRUPCIO   *******************
;*************                          *******************
;**********************************************************
;**********************************************************
;**********************************************************


;Si som aqui s perqu alguna interrupci ens hi ha portat
Inter
;primer de tot guardem el context
	movwf W_TEMP
	SWAPF STATUS,W
	clrf STATUS
	movwf STATUS_TEMP
	movf PCLATH, W
	movwf PCLATH_TEMP
	clrf PCLATH 
;Mirem quin flag s'ha activat, o b hem rebut una dada del GPS
;o b ha succeit un overflow en el timer1
	btfss PIR1,0
	goto prova_si_gps

	PAGESEL timer1_pag1
	goto timer1_pag1
	pagesel $

;Mirem si s'ha activat el flag de recepci del gps
prova_si_gps
;Si el flag de recepci s'ha activat salta la seguent instrucci
	btfss PIR1,RCIF 
	goto fi
;Posem el que hagim rebut a W
	movf RCREG,W   
;dada_rebuda contindr sempre al llarg de tota la interrupci l'ltima
;paraula que hem rebut
	movwf dada_rebuda


;********      Hem rebut un caracter    *******************
;********     que haurem guardat a W    *******************

;Comena el nostre diagrama d'estats
;A la memria del projecte podem veure a qu equival cada estat

;Tots els estats tindran aquesta capsalera, mirem quin ha estat l'estat anterior
;i el comparem amb l'estat on ens trobem. Si coincideix entrem dins l'algorisme 
;de l'estat, si no, passem el segent estat i repetim el procs.
estat0	movf estat_anterior,W
		xorlw .0;
		btfss STATUS, Z
		goto estat1	
;vigilem que la USART no es pari per un solapament de dades en el buffer.
		btfsc RCSTA,1
		goto arrecla_serie
		movf dada_rebuda,W

; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		xorlw '$' 
		btfss STATUS, Z
		goto fi
		
		movlw .1
        movwf estat_anterior

        goto fi
arrecla_serie
		bcf RCSTA,4
		bsf RCSTA,4
		goto fi

;Els segents estats ens serviran per conixer la capsalera del trama de dades
;que ens envia el gps, aix sabrem quina informaci n'hem de treure.
estat1 
		movf estat_anterior,W
		xorlw .1
		btfss STATUS, Z
		goto estat2	
     	movf dada_rebuda,W
; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		xorlw 'P' 
		btfss STATUS, Z
		goto probP1
		movlw .6
        movwf estat_anterior
        goto fi
probP1
		movf dada_rebuda,W
		xorlw 'G' 
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		movlw .2
        movwf estat_anterior
        goto fi
        
 
estat2
 		movf estat_anterior,W
		xorlw .2;
		btfss STATUS, Z
		goto estat3	
		movf dada_rebuda,W
		xorlw 'R' 
		btfss STATUS, Z
		goto proba_P
		movf dada_rebuda,W
		movlw .3
        movwf estat_anterior
        goto fi
proba_P 
 		movf dada_rebuda,W
		xorlw 'P' 
		btfss STATUS, Z
		goto probaG
		goto fi
probaG 	movf dada_rebuda,W
		xorlw 'G' 
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		movlw .16
        movwf estat_anterior
        goto fi
 		
estat3 
		movf estat_anterior,W
		xorlw .3
		btfss STATUS, Z
		goto estat4	
		movf dada_rebuda,W
		xorlw 'M' 
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		movlw .4
        movwf estat_anterior
        goto fi      
  
 estat4
		movf estat_anterior,W
		xorlw .4;
		btfss STATUS, Z
		goto GRMC	
		movf dada_rebuda,W
		xorlw 'C' 
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		movlw .5
        movwf estat_anterior
        goto fi
      
  		
 estat6
  		movf estat_anterior,W
		xorlw .6
		btfss STATUS, Z
		goto estat7	
		movf dada_rebuda,W
		xorlw 'R' 
		btfss STATUS, Z
		goto torna_estat0	
		movf dada_rebuda,W
		movlw .7
        movwf estat_anterior
        goto fi 
 

estat7
		movf estat_anterior,W
		xorlw .7;
		btfss STATUS, Z
		goto estat8
		movf dada_rebuda,W
		xorlw 'W'
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		movlw .8
        movwf estat_anterior
        goto fi 


estat8
		movf estat_anterior,W
		xorlw .8;
		btfss STATUS, Z
		goto estat9	
		movf dada_rebuda,W
		xorlw 'I' 
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		movlw .9
        movwf estat_anterior
        goto fi 
   
estat9
 		movf estat_anterior,W
		xorlw .9
		btfss STATUS, Z
		goto estat10	
		movf dada_rebuda,W
		xorlw 'Z' 
		btfss STATUS, Z
		goto probaR
		movf dada_rebuda,W
		movlw .10
        movwf estat_anterior
        goto fi 
probaR	movf dada_rebuda,W
		xorlw 'R' 
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		movlw .13
        movwf estat_anterior
        goto fi
  
estat10
 		movf estat_anterior,W
		xorlw .10;
		btfss STATUS, Z
		goto estat11	
		movf dada_rebuda,W
		xorlw 'C' 
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		movlw .11
        movwf estat_anterior
        goto fi 
        
estat11
 		movf estat_anterior,W
		xorlw .11
		btfss STATUS, Z
		goto PRWIZCH	
		movf dada_rebuda,W
		xorlw 'H' 
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		movlw .12
        movwf estat_anterior
        goto fi 
        
 estat13
 		movf estat_anterior,W
		xorlw .13;
		btfss STATUS, Z
		goto estat14	
		movf dada_rebuda,W
		xorlw 'I' 
		btfss STATUS, Z
		goto torna_estat0	
		movf dada_rebuda,W
		movlw .14
        movwf estat_anterior
        goto fi 
        
 estat14
 		movf estat_anterior,W
		xorlw .14;
		btfss STATUS, Z
		goto PRWIRID	
		movf dada_rebuda,W
		xorlw 'D' 
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		movlw .15
        movwf estat_anterior
        goto fi 
        
;Si comprobem que hem rebut la trama PRWIRID tornarem a l'estat0
;ja que aquesta trama no ens interessa.
      
PRWIRID
		movf estat_anterior,W
		xorlw .15
		btfss STATUS, Z
		goto estat16
		goto torna_estat0
		
		
estat16
 		movf estat_anterior,W
		xorlw .16;
		btfss STATUS, Z
		goto estat17	
		movf dada_rebuda,W
		xorlw 'G' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto probaS	
		movf dada_rebuda,W
		movlw .17
        movwf estat_anterior
        goto fi 
probaS	movf dada_rebuda,W
		xorlw 'S' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0	
		movf dada_rebuda,W
		movlw .19
        movwf estat_anterior
        goto fi 

estat17
 		movf estat_anterior,W
		xorlw .17;
		btfss STATUS, Z
		goto GPGGA	
		movf dada_rebuda,W
		xorlw 'A' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0	
		movf dada_rebuda,W
		movlw .18
        movwf estat_anterior
        goto fi 
  
 estat19
  		movf estat_anterior,W
		xorlw .19;
		btfss STATUS, Z
		goto GPGSA	
		movf dada_rebuda,W
		xorlw 'A' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		movlw .20
        movwf estat_anterior
        goto fi 

;************** Mirem si som a GRMC i comencem l'algorisme de captar les dades ********
  GRMC
  		movf estat_anterior,W
		xorlw .5
		btfss STATUS, Z
		goto estat6	
		movf dada_rebuda,W
		xorlw ',' 
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		movlw .21
        movwf estat_anterior
        goto fi
         
  ;*******EN AQUESTA PART INTENTEM CAPTURAR LA HORA*******
  estat21
		
  		movf estat_anterior,W
		xorlw .21;
		btfss STATUS, Z
		goto estat22	

		;***aqui agafem els 6 digits corresponents a l'hora****
		call captura_hora
		movf comptador_hora,W
		xorlw .6
		btfss STATUS, Z
		goto fi
		movlw .22
        movwf estat_anterior
        movlw .0
        movwf comptador_hora
        goto fi 
 
;Aquesta subrutina es tracta de generar un petit diagrama d'estats dins 
;l'estat21, per aix, anar agafant tots el carcters corresponents a l'hora.
;Tindrem doncs la variable comptador_hora que ens dir en quin estat estem.
;la compararem amb un literal, si coincideix continuarem, si no saltem al 
;segent estat
 captura_hora
 		movf comptador_hora,W ;incrementem captura_hora en 1
 		addlw .1
 		movwf comptador_hora
		movf comptador_hora,W
		xorlw .1;
		btfss STATUS, Z
		goto DirHora1
		movf dada_rebuda,W
		movf dada_rebuda,W
		movwf hora2
		goto fi_hora
		
DirHora1

		movf comptador_hora,W
		xorlw .2;
		btfss STATUS, Z
		goto DirMin2
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf hora1
		goto fi_hora

DirMin2	
		movf comptador_hora,W
		xorlw .3;
		btfss STATUS, Z
		goto DirMin1
		movf dada_rebuda,W
		movf dada_rebuda,W
		movwf minut2
		goto fi_hora

DirMin1
		movf comptador_hora,W
		xorlw .4;
		btfss STATUS, Z
		goto DirSeg2
		movf dada_rebuda,W
		movf dada_rebuda,W
		movwf minut1
		goto fi_hora

DirSeg2
		movf comptador_hora,W
		xorlw .5;
		btfss STATUS, Z
		goto DirSeg1
		movf dada_rebuda,W
		movf dada_rebuda,W
		movwf segon2
		goto fi_hora

DirSeg1
		movf comptador_hora,W
		xorlw .6;
		btfss STATUS, Z
		goto fi_hora
		movf dada_rebuda,W
		movf dada_rebuda,W
		movwf segon1
		movf pantalla,w
		xorlw 0x12
		btfsc STATUS,Z	
		goto continuah
		call corretgir_hora
		movlw .1
		movwf hora_borrada
		movlw .0
		banksel punter_sat_nivells
		movwf punter_sat_nivells
		call punter
		call escriu_hora
		goto fi_hora
continuah
		movf hora_borrada,W
		xorlw .1
		btfss STATUS,Z
		goto fi_hora
		clrf hora_borrada
		movlw .0
		banksel punter_sat_nivells
		movwf punter_sat_nivells
		call punter
		call escriu_hora_buida
fi_hora	
return 					
 
;Aquesta subrutina agafa les variables data2 i data1, treu els 4 bits de ms pes,
;rota 4 vegades valor2 i fa una OR amb valor1,el resultat queda a W.
;Ex: data2=0x34 data1=0x31 => W= 0x14
passa_desenes_i_unitats_a_un
	banksel data2
	movfw data2
	banksel valor1
	andlw 0x0F
	movwf valor1
;ja hem borrat la part alta de valor1, fem el mateix per valor
	banksel data1
	movfw data1
	andlw 0x0F
	banksel valor2
	movwf valor2	
;rotem valor2 4 cops a travs del carry
	bcf STATUS,C
	rlf valor2,1	
	rlf valor2,1
	rlf valor2,1
	rlf valor2,1
;ara queda suma els valors
	movfw valor2
	iorwf valor1,0
	movwf resultat_bcd
return

corretgir_hora
;mirem si el mes es gener,febrer,novembre o desembre i li sumem +1

	banksel data4	
	movfw data4
	xorlw 0x31
	btfsc STATUS,Z
	goto suma_hora_1
	banksel data4
	movfw data4
	xorlw 0x32
	btfsc STATUS,Z
	goto suma_hora_1
;	haurem de vigilar amb el mar
	banksel data4
	movfw data4
	xorlw 0x33
	btfss STATUS,Z
	goto proba_si_octubre

	;som al mar
	;mirem a quin any som
	banksel data6	
	movfw data6
	xorlw 0x37
	btfss STATUS,Z
	goto mira_any_2008
	;som al mar del 2007
	;hem de treure la dada de l'adrea 00 de la memoria EEPROM
	call passa_desenes_i_unitats_a_un
	movlw  0x00
	banksel ADDR
	movwf ADDR
	call llegir_eeprom
	banksel resultat_bcd
	subwf resultat_bcd,0 ;F-w=>desti
	btfsc STATUS,C
	goto suma_hora_2
	;Si la resta entre el dia que som i el dia del canvi provoca carry
	;es que encara no hi hem arribat, i per tant es horari d'hivern
	goto suma_hora_1

mira_any_2008
	banksel data6	
	movfw data6
	xorlw 0x38
	btfss STATUS,Z
	goto mira_any_2009
	;som al mar del 2008
	;hem de treure la dada de l'adrea 02 de la memoria EEPROM
	call passa_desenes_i_unitats_a_un
	movlw 0x02
	banksel ADDR
	movwf ADDR
	call llegir_eeprom
	banksel resultat_bcd
	subwf resultat_bcd,0
	btfsc STATUS,C
	goto suma_hora_2
	;Si la resta entre el dia que som i el dia del canvi provoca carry
	;es que encara no hi hem arribat, i per tant es horari d'hivern
	goto suma_hora_1
mira_any_2009
banksel data6	
	movfw data6
	xorlw 0x39
	btfss STATUS,Z
	goto mira_any_2010
	;som al mar del 2007
	;hem de treure la dada de l'adrea 04 de la memoria EEPROM
	call passa_desenes_i_unitats_a_un
	movlw 0x04
	banksel ADDR
	movwf ADDR
	call llegir_eeprom
	banksel resultat_bcd
	subwf resultat_bcd,0
	btfsc STATUS,C
	goto suma_hora_2
	;Si la resta entre el dia que som i el dia del canvi provoca carry
	;es que encara no hi hem arribat, i per tant es horari d'hivern
	goto suma_hora_1
mira_any_2010
banksel data6	
	movfw data6
	xorlw 0x30
	btfss STATUS,Z
	goto suma_hora_1
	;som al mar del 2007
	;hem de treure la dada de l'adrea 06 de la memoria EEPROM
	call passa_desenes_i_unitats_a_un
	movlw 0x06
	banksel ADDR
	movwf ADDR
	call llegir_eeprom
	banksel resultat_bcd
	subwf resultat_bcd,0
	btfsc STATUS,C
	goto suma_hora_2
	goto suma_hora_1
	;Si la resta entre el dia que som i el dia del canvi provoca carry
	;es que encara no hi hem arribat, i per tant es horari d'hivern
proba_si_octubre

	banksel data4	
	movfw data4
	xorlw 0x30
	btfss STATUS,Z
	goto suma_hora_2

	;som al mar
	;mirem a quin any som
	banksel data6	
	movfw data6
	xorlw 0x37
	btfss STATUS,Z
	goto mira_any_2008_oct
	;som al octubre del 2007
	;hem de treure la dada de l'adrea 01 de la memoria EEPROM
	call passa_desenes_i_unitats_a_un
	movlw  0x01
	banksel ADDR
	movwf ADDR
	call llegir_eeprom
	banksel resultat_bcd
	subwf resultat_bcd,0 ;F-w=>desti
	btfss STATUS,C
	goto suma_hora_2
	;Si la resta entre el dia que som i el dia del canvi provoca carry
	;es que encara no hi hem arribat, i per tant es horari d'hivern
	goto suma_hora_1

mira_any_2008_oct
	;mirem a quin any som
	banksel data6	
	movfw data6
	xorlw 0x38
	btfss STATUS,Z
	goto mira_any_2009_oct
	;som al octubre del 2008
	;hem de treure la dada de l'adrea 03 de la memoria EEPROM
	call passa_desenes_i_unitats_a_un
	movlw  0x03
	banksel ADDR
	movwf ADDR
	call llegir_eeprom
	banksel resultat_bcd
	subwf resultat_bcd,0 ;F-w=>desti
	btfss STATUS,C
	goto suma_hora_2
	;Si la resta entre el dia que som i el dia del canvi provoca carry
	;es que encara no hi hem arribat, i per tant es horari d'hivern
	goto suma_hora_1

mira_any_2009_oct
	;mirem a quin any som
	banksel data6	
	movfw data6
	xorlw 0x39
	btfss STATUS,Z
	goto mira_any_2010_oct
	;som al octubre del 2009
	;hem de treure la dada de l'adrea 05 de la memoria EEPROM
	call passa_desenes_i_unitats_a_un
	movlw  0x05
	banksel ADDR
	movwf ADDR
	call llegir_eeprom
	banksel resultat_bcd
	subwf resultat_bcd,0 ;F-w=>desti
	btfss STATUS,C
	goto suma_hora_2
	;Si la resta entre el dia que som i el dia del canvi provoca carry
	;es que encara no hi hem arribat, i per tant es horari d'hivern
	goto suma_hora_1

mira_any_2010_oct
	;mirem a quin any som
	banksel data6	
	movfw data6
	xorlw 0x30
	btfss STATUS,Z
	goto suma_hora_2
	;som al octubre del 2010
	;hem de treure la dada de l'adrea 07 de la memoria EEPROM
	call passa_desenes_i_unitats_a_un
	movlw  0x07
	banksel ADDR
	movwf ADDR
	call llegir_eeprom
	banksel resultat_bcd
	subwf resultat_bcd,0 ;F-w=>desti
	btfss STATUS,C
	goto suma_hora_2
	;Si la resta entre el dia que som i el dia del canvi provoca carry
	;es que encara no hi hem arribat, i per tant es horari d'hivern
	goto suma_hora_1

suma_hora_2	
	call rut_suma_hora_1
suma_hora_1	
	call rut_suma_hora_1
fi_corretgir_hora_pag2
return


;Aquesta subrutina llegiex el contingut de l'adrea ADDR que trobem a la EEPROM
;deixer el resultat a W
llegir_eeprom
	bsf STATUS,RP1
	bcf STATUS,RP0
	banksel ADDR
	movf ADDR,W
	banksel EEADR
	movwf EEADR
	bsf STATUS,RP0
	bcf EECON1,EEPGD
	bsf EECON1,RD
	bcf STATUS,RP0
	movf EEDATA,W
return
rut_suma_hora_1
	;si al sumar un 1 a l'hora passa de 9 a 10, posarem hora1=0 i hora2=hora2+1
	banksel data4
	movfw hora1
	addlw .1
	movwf hora1
	xorlw 0x3A
	btfss STATUS,Z
	goto mira_si_hora_24
	banksel data4
	movfw hora2
	addlw .1
	movwf hora2
	clrf hora1
	goto fi_corretgir

mira_si_hora_24
	;L'hora 24 no existeix i per tant l'hem de canviar a 00
	banksel data4
	movfw hora1
	xorlw 0x34
	btfss STATUS,Z
	goto fi_corretgir
	movfw hora2
	xorlw 0x32
	btfss STATUS,Z
	goto fi_corretgir
	;marca les 24 hores, per tant posarem 00
	clrf hora1
	clrf hora2
fi_corretgir
	banksel data1
return

 estat22
 		movf estat_anterior,W
		xorlw .22
		btfss STATUS, Z
		goto estat23	
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,
		movlw .23
        movwf estat_anterior
        goto fi
 
 ;*******EN AQUESTA PART MIRAREM SI LES DADES SON VALIDES*******
;Una part important de rebre les dades s saber quan aquestes son certes,
;Si rebem la lletra A es que ho son, altrament rebrem dades pero avisarem
;que son falses.
 estat23
 		movf estat_anterior,W
		xorlw .23
		btfss STATUS, Z
		goto estat24


		movf dada_rebuda,W
		movwf posicio_valida	
 		movf dada_rebuda,W
 		xorlw 0x41;LLETRA A
        btfss STATUS, Z
	    goto noValid
	    goto valid
 noValid
;la variable validesa_borrada ens recorda si anteriorment hem borrat o no
;de la pantalla el rtol de Dades NO vlides
		movlw .1
		movwf validesa_borrada
;Escribim Dades NO vlides
		movlw .67
		banksel punter_sat_nivells
		movwf punter_sat_nivells
		call punter
 		call escriu_dadaNoValida	
 		goto fi_estat23
 valid  
;si les dades son vlides, treiem un cop el rtol de Dades NO vlides
		movfw validesa_borrada
		xorlw .1
		btfss STATUS,Z
		goto fi_estat23
		movlw .67
		banksel punter_sat_nivells
		movwf punter_sat_nivells
		call punter
 		call escriu_dadaNoValida_buida
		clrf validesa_borrada	
 		goto fi_estat23				
fi_estat23	
		movlw .24
        movwf estat_anterior
        goto fi
   
 estat24
 		movf estat_anterior,W
		xorlw .24
		btfss STATUS, Z
		goto estat25
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		movlw .25
        movwf estat_anterior
        goto fi
 
 ;*******EN AQUESTA PART MIRAREM LA PRIMERA COORDENADA *******
 estat25
  		movf estat_anterior,W
		xorlw .25;
		btfss STATUS, Z
		goto estat26	
;Aqui agafem els 9 digits corresponents a la 1a coordenada 1
		call captura_coordenada1
		movf comptador_coordenada1,W
		xorlw .9
		btfss STATUS, Z
		goto fi
		movlw .26
        movwf estat_anterior
        movlw .0
        movwf comptador_coordenada1
        goto fi 
 
;Com he fet amb l'hora hem creat un altre diagrama d'estats per recollir 
;tots els valor de la coordenada1. La variable comptador_coordenada1 ens diu
;el nmero d'estat
 captura_coordenada1
;incrementem en 1 comptador_coordenada1 per avanar a l'estat segent
 		movf comptador_coordenada1,W 
 		addlw .1
 		movwf comptador_coordenada1
		movf comptador_coordenada1,W
		xorlw .1;
		btfss STATUS, Z
		goto DirCoord1
		movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada1_deg2
		goto fi_coordenades1
		

DirCoord1

		movf comptador_coordenada1,W
		xorlw .2;
		btfss STATUS, Z
		goto DirCoord2
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada1_deg1
		goto fi_coordenades1

DirCoord2

		movf comptador_coordenada1,W
		xorlw .3;
		btfss STATUS, Z
		goto DirCoord3
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada1_min7
		goto fi_coordenades1

DirCoord3

		movf comptador_coordenada1,W
		xorlw .4;
		btfss STATUS, Z
		goto DirCoord4
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada1_min6
		goto fi_coordenades1
		
DirCoord4

		movf comptador_coordenada1,W
		xorlw .5;
		btfss STATUS, Z
		goto DirCoord5
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada1_min5
		goto fi_coordenades1
		
DirCoord5

		movf comptador_coordenada1,W
		xorlw .6;
		btfss STATUS, Z
		goto DirCoord6
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada1_min4
		goto fi_coordenades1
		
DirCoord6

		movf comptador_coordenada1,W
		xorlw .7;
		btfss STATUS, Z
		goto DirCoord7
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada1_min3
		goto fi_coordenades1
		
DirCoord7

		movf comptador_coordenada1,W
		xorlw .8;
		btfss STATUS, Z
		goto DirCoord8
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada1_min2
		goto fi_coordenades1
		
DirCoord8

		movf comptador_coordenada1,W
		xorlw .9;
		btfss STATUS, Z
		goto fi_coordenades1
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada1_min1

;Aqui veiem la variable pantalla que pot tenir el valors 0x10,0x11,0x12,
;el valor ens indica quina de les 3 pantalles estem en un moment concret.
;L'haurem de consultar per veure si cal escriure o no.

		movf pantalla,w
		xorlw 0x10
		btfss STATUS,Z	
		goto continuaCoor1
		movlw .1
		movwf coordenada1_borrada
		movlw .90
		banksel punter_sat_nivells
		movwf punter_sat_nivells
		call punter
        call escriu_Coor
		movlw .102
		banksel punter_sat_nivells
		movwf punter_sat_nivells
		call punter
		call escriu_coordenada1	
		goto fi_coordenades1
continuaCoor1
		movf coordenada1_borrada,W
		xorlw .1
		btfss STATUS,Z
		goto fi_coordenades1
		clrf coordenada1_borrada
		movlw .90
		banksel punter_sat_nivells
		movwf punter_sat_nivells
		call punter
		call escriu_coordenada1_buida	
;continua_dir4
		goto fi_coordenades1
 fi_coordenades1
		
 return		
        

 estat26
 		movf estat_anterior,W
		xorlw .26
		btfss STATUS, Z
		goto estat27	
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		;call putchar
		movlw .27
        movwf estat_anterior
        goto fi
   
;En aquest estat es tracta de guardar la orientaci de la coordenada
;pot ser Sud o Nord, i  la guardarem a la variable N_o_S
;N_o_S_borrada com anteriorment ens avisa si ja hem borrat un cop la pantalla
;si no s aix escribim blancs a sobre	
estat27
 		movf estat_anterior,W
		xorlw .27
		btfss STATUS, Z
		goto estat28
		movf dada_rebuda,W
		movwf N_o_S			
		movf pantalla,w
		xorlw 0x10
		btfss STATUS,Z	
		goto continuaNS
		movlw .1
		movwf N_o_S_borrada
		movlw .112
		banksel punter_sat_nivells
		movwf punter_sat_nivells
		call punter
		call escriu_N_o_S
		goto fi_N_o_S
continuaNS
		movf N_o_S_borrada,W
		xorlw .1
		btfss STATUS,Z
		goto fi_N_o_S
		clrf N_o_S_borrada
		movlw .112
		banksel punter_sat_nivells
		movwf punter_sat_nivells
		call punter
		call escriu_NS_EW_buida
fi_N_o_S	
		movlw .28
        movwf estat_anterior
        goto fi
   
     
estat28
 	 	movf estat_anterior,W
		xorlw .28
		btfss STATUS, Z
		goto estat29	
		movf dada_rebuda,W
		xorlw ',' 
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		movlw .29
        movwf estat_anterior
        goto fi	
   
   
 ;*******EN AQUESTA PART MIRAREM LA SEGONA COORDENADA *******

 estat29
 		
  		movf estat_anterior,W
		xorlw .29;
		btfss STATUS, Z
		goto estat30	
;Aqui agafem els 10 digits corresponents a la segona coordenada
;captura_coordenada2, tal com hem fet abans, s una subrutina  que ens porta cap a un
;altre diagrama d'estats per recollir els caracters que conformen la coordenada 2
		call captura_coordenada2
		movf comptador_coordenada2,W
		xorlw .10
		btfss STATUS, Z
		goto acaba2
		movlw .30
        movwf estat_anterior
        movlw .0
        movwf comptador_coordenada2
acaba2
        goto fi 
 
;Captura_coordenada2 es un altre diagrama d'estats dins de estat29 per
;capturar els valors de la 2a coordenada
 captura_coordenada2	
 		movf comptador_coordenada2,W 
 		addlw .1
 		movwf comptador_coordenada2
		movf comptador_coordenada2,W
		xorlw .1;
		btfss STATUS, Z
		goto DirCoord21
		movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada2_deg3
		goto fi_coordenades2
		

DirCoord21	
		movf comptador_coordenada2,W
		xorlw .2;
		btfss STATUS, Z
		goto DirCoord22
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada2_deg2
		goto fi_coordenades2

DirCoord22
		movf comptador_coordenada2,W
		xorlw .3;
		btfss STATUS, Z
		goto DirCoord23
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada2_deg1
		goto fi_coordenades2

DirCoord23
		movf comptador_coordenada2,W
		xorlw .4;
		btfss STATUS, Z
		goto DirCoord24
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada2_min7
		goto fi_coordenades2
		
DirCoord24
		movf comptador_coordenada2,W
		xorlw .5;
		btfss STATUS, Z
		goto DirCoord25
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada2_min6
		goto fi_coordenades2
		
DirCoord25	
		movf comptador_coordenada2,W
		xorlw .6;
		btfss STATUS, Z
		goto DirCoord26
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada2_min5
		goto fi_coordenades2
		
DirCoord26
		movf comptador_coordenada2,W
		xorlw .7;
		btfss STATUS, Z
		goto DirCoord27
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada2_min4
		goto fi_coordenades2
		
DirCoord27	
		movf comptador_coordenada2,W
		xorlw .8;
		btfss STATUS, Z
		goto DirCoord28
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada2_min3
		goto fi_coordenades2
		
DirCoord28		
		movf comptador_coordenada2,W
		xorlw .9;
		btfss STATUS, Z
		goto DirCoord29
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada2_min2
		goto fi_coordenades2

DirCoord29	
		movf comptador_coordenada2,W
		xorlw .10;
		btfss STATUS, Z
		goto fi_coordenades2
	    movf dada_rebuda,W
		movf dada_rebuda,W
		movwf coordenada2_min1
		movf pantalla,w
		xorlw 0x10
		btfss STATUS,Z	
		goto continuaCoor2
		movlw .1
		movwf coordenada2_borrada
		movlw .131
		banksel punter_sat_nivells
		movwf punter_sat_nivells
		call punter
		call escriu_coordenada2		
		goto fi_coordenades2
continuaCoor2
		movf coordenada2_borrada,W
		xorlw .1
		btfss STATUS,Z
		goto fi_coordenades2
		clrf coordenada2_borrada
		movlw .131
		banksel punter_sat_nivells
		movwf punter_sat_nivells
		call punter
		call escriu_coordenada2_buida		
 fi_coordenades2
 return	
 	
 estat30
 	 	movf estat_anterior,W
		xorlw .30
		btfss STATUS, Z
		goto estat31	
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		movlw .31
        movwf estat_anterior
        goto fi	
   
;Aqui capturem el valor de la orientaci de la segona coordenada que guardarem a
;E_o_W pot valdre E o W	
 estat31
 		movf estat_anterior,W
		xorlw .31
		btfss STATUS, Z
		goto estat32
		movf dada_rebuda,W
		movwf E_o_W
 		movf dada_rebuda,W
		movf pantalla,w
		xorlw 0x10
		btfss STATUS,Z	
		goto continuaEW
		movlw .1
		movwf E_o_W_borrada
		movlw .142
		banksel punter_sat_nivells
		movwf punter_sat_nivells
		call punter
		call escriu_E_o_W
		goto fi_E_o_W
continuaEW
		movf E_o_W_borrada,W
		xorlw .1
		btfss STATUS,Z
		goto fi_E_o_W
		clrf E_o_W_borrada
		movlw .142
		banksel punter_sat_nivells
		movwf punter_sat_nivells
		call punter
		call escriu_NS_EW_buida

fi_E_o_W	
		movlw .32
        movwf estat_anterior
        goto fi
       
estat32
 	 	movf estat_anterior,W
		xorlw .32
		btfss STATUS, Z
		goto prepara_el_salt33	
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0
		movf dada_rebuda,W
		movlw .33
        movwf estat_anterior
        goto fi	
  
;estat33 esta situat en una altre pagina de la memoria de programa per tant
;preparem el salt amb la directiva PAGESEL      
prepara_el_salt33	     
PAGESEL estat33
goto estat33
  		
;*********************** Fi de l'algorisme de GRMC *******************

;GPSA no ens interessa i tornem a portar al estat 0
GPGSA
		movf estat_anterior,W
		xorlw .20
		btfss STATUS, Z
		goto estat21
		goto torna_estat0

;Hem rebut la capsalera GPGGA i passem al segent estat on podrem  llegir les dades		
GPGGA
		movf estat_anterior,W
		xorlw .18
		btfss STATUS, Z
		goto estat19
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0
		movlw .38
        movwf estat_anterior
;preparem el comptador_data
		clrf comptador_data
        goto fi
         
;Hem rebut la capsalera PRWIZCH i passem al segent estat on podrem  llegir les dades	
PRWIZCH  	
		movf estat_anterior,W
		xorlw .12
		btfss STATUS, Z
		goto estat13

		movlw .54
        movwf estat_anterior
        goto fi	

;Aquesta subrutina ens torna a l'estat 0		
 torna_estat0	
 		movlw .0
        movwf estat_anterior
        goto fi

;fi ens porta cap al final de la rutina de servei a l'interrupci, per est a
;l'ltima pgina de memoria de programa, per tant utilitzem el PAGESEL
fi
PAGESEL fi_pag1
goto fi_pag1


;******************************************************
;************* CANVI DE PGINA*************************
;******************************************************

;La segona pgina de memoria de programa comena a l'adressa 0x800 per tant ens situem all
ORG 0x800

;Les subrutines ms utilizades les replicarem a cada pgina.
;Com a la pgina 0 aquesta subrutina ens neteja la pantalla
neteja_pantalla_pag1
	movlw d'239'
	movwf proba
Bucle_pag1	
	call status_check_pag1
	movlw 0x00
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1
	decfsz proba,1
	goto Bucle_pag1

return

;L'Status_check es una comprobaci que fem per saber si l'LCD esta llest per
;rebre noves dades. Es tracta de comprobar si STA0 i STA1 estan a 1, Aquesta paraula
;d'estat la rebem pel portB, activant RD->L CE->L WR->H C/D->H
status_check_pag1

;Canviem de Bank i posem el portB com a entrada
	bsf STATUS,RP0
	movlw 0xFF
	movwf TRISB
;Tornem al Bank 0
	bcf STATUS,RP0
;Activem les senyals
	bsf WR
	bsf C_D
	bcf R_D
	bcf C_E
refresca_pag1	
	nop
	nop 
;llegim STA0 i STA1
	btfss PORTB,0
	goto refresca_pag1	

	btfss PORTB,1
	goto refresca_pag1	
	nop
	nop
	nop
;cambiem el valors dels senyals de control
	bsf C_E
	bcf C_D
;tornem a configurar PORTB com a sortida
	bsf STATUS,RP0
	clrf TRISB
	bcf STATUS,RP0
	
return


envia_dada_pag1
;Envia una dada pel portB
	call status_check_pag1
;Per enviar una dada s'han de tenir activat WR=L, C/D=L
	bsf C_D
	bsf R_D
	bsf WR
;coloquem la dada que tenim a W al port B
	movf TEMP,w
	movwf PORTB
;activem la escriptura
	bcf WR
	bcf C_D
	bcf C_E
	nop 
	nop
	nop
	nop
	bsf WR
	bsf C_D
	bsf C_E
return

envia_comanda_pag1
;Per enviar una comanda activarem aquests senyals de control WR=L i C/D=H
	call status_check_pag1
	bsf C_D
	bsf WR
	bsf R_D
;movem la dada al portB
	movf TEMP,w
	movwf PORTB
;activem l'escriptura de comanda
	bcf WR
	bcf C_E
	nop
	nop
	nop
	nop
	nop
	nop
	bsf WR
	bsf C_E
return


;*********hem canviat el valor de pantalla per km per comprobar el funcionament de km

escriu_pantalla
	call status_check_pag1
	movf km,W
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1
return

;Si estem aqui s perqu ha succeit un overflow en el timer1
;Aquest overflow ens far consultar els pulsadors i evitar els
;seus rebots
timer1_pag1
	;banksel punter_sat_nivells
	;movlw .0
	;movwf punter_sat_nivells
	;banksel proba
	;call punter_pag1
	;call escriu_pantalla
	btfsc pulsador
	goto mira_estat_anterior_pulsador
	bsf PORTA,0
	movf apretat1,W
	addlw .1
	movwf apretat1

;ja hem mirat el pulsador 1 que ens indiqui quina pantalla hem de mostrar
;ara mirem el pulsador2 que ens diu si hem de mostrar la velocitat en km/h
;o nusos

mira_pulsador2
	btfsc pulsador2
	goto mira_estat_anterior_pulsador2
	movf kilometres_apretat,W
	addlw .1
	movwf kilometres_apretat
	goto restaura

mira_estat_anterior_pulsador2
;mirem si anteriorment s'havia apretat el pulsador durant almenys 120ms
	movfw kilometres_apretat
	xorlw 0x00
	btfsc STATUS, Z
	goto restaura
	movfw kilometres_apretat
	xorlw 0x01
	btfsc STATUS, Z
	goto posa_0_contador_km
;aqui va el que ha de passar quan haguem deixat anar el pulsador
	clrf kilometres_apretat
	movfw km
	addlw .1
	movwf km
;km nomes pot tenir els valor 0 o 1, per tant si veiem que te valor 2
;nosaltres el forcem a 0
	xorlw 0x02
	btfss STATUS,Z
	goto restaura			
	clrf km 

posa_0_contador_km
	clrf kilometres_apretat
	goto restaura

;Aqui mirem si a l'estat anterior la tecla havia estat premuda
;el pulsador ser efectiu en el seu flanc ascendent
 mira_estat_anterior_pulsador
;Mirem si anteriorment s'havia apretat el pulsador durant almenys 120ms
	movf apretat1,0
	xorlw 0x00
	btfsc STATUS, Z
	goto mira_pulsador2
	movf apretat1,0
	xorlw 0x01
	btfsc STATUS, Z
	goto posa_0_contador
;Aqui va el que ha de passar quan haguem deixat anar el pulsador una vegada
;filtrats els rebots. Es tracta de sumar 1 a la variable pantalla que controla
;en quina de les 3 pantalles possibles estem.
	;call punter_pag1
	;call neteja_pantalla_pag1
	movf pantalla,W
	addlw .1
	movwf pantalla_temp
;de la pantalla 3 passem a la 0
	xorlw 0x13
	btfss STATUS,Z
	goto guarda_pantalla			
	movlw 0x10
	movwf pantalla	
	goto posa_0_contador

guarda_pantalla
	movf pantalla_temp,W
	movwf pantalla
	
;Aqui posem a 0 el contador de vegades seguides que el pulsador estava apretat	
posa_0_contador	
	clrf apretat1
	goto mira_pulsador2
;Restaura flag i valor de recrrega del timer1	

restaura   
;Finalment restaurem el flag
	bcf	 PIR1,TMR1IF 
	clrf TMR1L
    clrf TMR1H
	goto fi_pag1

;Tal com a la pgina0, la rutina colloca el punter al nombre que ens diu
;la variable punter_sat_nivells
punter_pag1
	call status_check_pag1
	banksel punter_sat_nivells
	movfw punter_sat_nivells
	banksel TEMP
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0x00
	banksel TEMP
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	banksel TEMP
	movlw 0x24
	movwf TEMP
	call envia_comanda_pag1
	call status_check_pag1
return

;Aquesta subrutina escriu la data amb aquest format
;data1 data2-data3 data4-datat5 data6
escriu_data
	call status_check_pag1
	movf data1,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	
 
	call status_check_pag1
	movf data2,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	
 

	call status_check_pag1	
	movlw 0x0D
	movwf TEMP
	call envia_dada_pag1	
	call status_check_pag1	
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1
	movf data3,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	
 
	call status_check_pag1
	movf data4,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	
 

	call status_check_pag1	
	movlw 0x0D
	movwf TEMP
	call envia_dada_pag1	
	call status_check_pag1	
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1
	movf data5,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	
 
	call status_check_pag1
	movf data6,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	
 return

;Escriu a l'LCD el nombre de satelits trobats, ho escriu aix
;S satelit2satelit1
escriu_satelit
	call status_check_pag1	
	movlw 0x33
	movwf TEMP
	call envia_dada_pag1	
	call status_check_pag1	
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1	
	movlw 0x00
	movwf TEMP
	call envia_dada_pag1	
	call status_check_pag1	
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1
	movf satelit2,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	
 
	call status_check_pag1
	movf satelit1,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	
return

;Escriu per l'LCD
;Velocitat(seguit dels caracters que marquen la velocitat)
escriu_velocitat
	banksel TEMP
	call status_check_pag1
	movlw 0x36
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1

	call status_check_pag1
	movlw 0x45
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1
	movlw 0x4C
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	
	
	call status_check_pag1
	movlw 0x4F
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1

	call status_check_pag1
	movlw 0x43
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1
	movlw 0x49
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1
	movlw 0x54
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1

	call status_check_pag1
	movlw 0x41
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1
	movlw 0x54
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1
	movlw 0x00
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1





	call status_check_pag1
	movf velocitat1,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP

	xorlw 0x1E
	btfss STATUS,Z
	goto velocitat1_punt
	movlw 0x0E
	movwf TEMP
velocitat1_punt
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	




	call status_check_pag1
	movf velocitat2,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	xorlw 0x1E
	btfss STATUS,Z
	goto velocitat2_punt
	movlw 0x0E
	movwf TEMP
velocitat2_punt
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	



	call status_check_pag1
	movf velocitat3,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	xorlw 0x1E
	btfss STATUS,Z
	goto velocitat3_punt
	movlw 0x0E
	movwf TEMP
velocitat3_punt
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	




	call status_check_pag1
	movf velocitat4,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	xorlw 0x1E
	btfss STATUS,Z
	goto velocitat4_punt
	movlw 0x0E
	movwf TEMP
velocitat4_punt
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	


	call status_check_pag1
	movf velocitat5,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	xorlw 0x1E
	btfss STATUS,Z
	goto velocitat5_punt
	movlw 0x0E
	movwf TEMP
velocitat5_punt
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	



	call status_check_pag1
	movf velocitat6,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP
	xorlw 0x1E
	btfss STATUS,Z
	goto velocitat6_punt
	movlw 0x0E
	movwf TEMP
velocitat6_punt
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	
 
	call status_check_pag1
	movlw 0x00
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	banksel km
	movfw km
	xorlw .0
	btfss STATUS,Z
	goto escriu_km
	;escriurem nusos
	call status_check_pag1
	movlw 0x4E
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1
	movlw 0x55
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1

	call status_check_pag1
	movlw 0x53
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1

	call status_check_pag1
	movlw 0x4F
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1

	call status_check_pag1
	movlw 0x53
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1

	goto fi_escriure_velocitat

escriu_km

	call status_check_pag1
	movlw 0x4B
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1

	call status_check_pag1
	movlw 0x4D
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1

	call status_check_pag1
	movlw 0x0F
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1

	call status_check_pag1
	movlw 0x48
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1
fi_escriure_velocitat
return


;Escriu carcters en blanc all on posava la velocitat
escriu_velocitat_buida	
	movlw d'23'
	movwf proba
Bucle_velocitat	
	call status_check_pag1
	movlw 0x00
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1
	decfsz proba,1
	goto Bucle_velocitat
return

;Escriu carcters en blanc all on posava la data
escriu_data_buida	
	movlw d'10'
	movwf proba
Bucle_data	
	call status_check_pag1
	movlw 0x00
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1
	decfsz proba,1
	goto Bucle_data
return

;Escriu carcters en blanc all on posava el nombre de satlits
escriu_satelit_buida
	movlw d'5'
	movwf proba
Bucle_direccio	
	call status_check_pag1
	movlw 0x00
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1
	decfsz proba,1
	goto Bucle_direccio
return

;Escriu carcters en blanc all on posava la direcci
escriu_direccio_buida	
	movlw d'17'
	movwf proba
Bucle_sat	
	call status_check_pag1
	movlw 0x00
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1
	decfsz proba,1
	goto Bucle_sat
return

;Escriu les lletres direcci a l'LCD seguit d'un espai
;i finalment la direcci
escriu_direccio
	call status_check_pag1
	movlw 0x24
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1
	movlw 0x49
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1
	movlw 0x52
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	
	
	call status_check_pag1
	movlw 0x45
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1
	movlw 0x43
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1
	movlw 0x43
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1
	movlw 0x49
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1
	movlw 0x4F
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

	call status_check_pag1
	movlw 0x00
	movwf TEMP
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	


;Aqui escribim la direcci pero vigilant que si trobem un '>' l'hem de canviar per un '.'
	call status_check_pag1
	movf direccio1,w
	andlw 0x0F
	iorlw 0x10

    movwf TEMP
	xorlw 0x1E
	btfss STATUS,Z
	goto direccio1_punt
	movlw 0x0E
	movwf TEMP
direccio1_punt

	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	
	call status_check_pag1
	movf direccio2,w
	andlw 0x0F
	iorlw 0x10
    movwf TEMP
	xorlw 0x1E
	btfss STATUS,Z
	goto direccio2_punt
	movlw 0x0E
	movwf TEMP
direccio2_punt

	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	
	call status_check_pag1
	movf direccio3,w
	andlw 0x0F
	iorlw 0x10
    movwf TEMP
	xorlw 0x1E
	btfss STATUS,Z
	goto direccio3_punt
	movlw 0x0E
	movwf TEMP

direccio3_punt
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	
	call status_check_pag1
	movf direccio4,w
	andlw 0x0F
	iorlw 0x10
    movwf TEMP
	xorlw 0x1E
	btfss STATUS,Z
	goto direccio4_punt
	movlw 0x0E
	movwf TEMP

direccio4_punt
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	
	call status_check_pag1
	movf direccio5,w
	andlw 0x0F
	iorlw 0x10
    movwf TEMP
	xorlw 0x1E
	btfss STATUS,Z
	goto direccio5_punt
	movlw 0x0E
	movwf TEMP

direccio5_punt
	call envia_dada_pag1
	call status_check_pag1
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag1	

return

;Aqui llegirem la velocitat en nusos
estat33		
  		movf estat_anterior,W
		xorlw .33;
		btfss STATUS, Z
		goto estat34	
;***aqui agafem els 6 digits corresponents a la velocitat****
		call captura_velocitat
		movf comptador_velocitat,W
		xorlw .6
		btfss STATUS, Z
		goto fi_pag1
		movf proba,W
		xorlw .123
		btfss STATUS,Z
		goto continua_normal
		movlw .35
        movwf estat_anterior
        movlw .0
        movwf comptador_velocitat
		clrf proba
        goto fi_pag1  

continua_normal
		movlw .34
        movwf estat_anterior
        movlw .0
        movwf comptador_velocitat
        goto fi_pag1  
 


hiha_coma
;Modifica el valor de es-coma, si es 0 no hem llegit cap coma, si es un 1 si
		
		movlw .0
		movwf es_coma
		movf dada_rebuda,W
		;comprobem que no hem rebut una coma.
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto fi_es_coma
		;si es es_coma=1 llavors vol dir que hiha una coma
		movlw .1
		movwf es_coma

fi_es_coma		

return

es_coma_velocitat
;Posa a 0  totes les variables de velocitat si detectem un coma en lloc de un numero
		banksel velocitat3
		call hiha_coma
		movf es_coma,W
		xorlw .1;
		btfss STATUS, Z
		goto fi_es_coma_velocitat
		;emplena_velocitat_zeros
   		movlw 0x10
        movwf velocitat1
		movwf velocitat2
		movwf velocitat3
		movwf velocitat4
		movwf velocitat5
		movwf velocitat6
		movlw .6
        movwf comptador_velocitat
		movlw .123
		movwf proba
		
fi_es_coma_velocitat
return


 captura_velocitat
 		banksel velocitat1
 		movf comptador_velocitat,W 
 		addlw .1
 		movwf comptador_velocitat
		movf comptador_velocitat,W
		xorlw .1;
		btfss STATUS, Z
		goto vel1
		movf dada_rebuda,W
		movwf velocitat1
		call es_coma_velocitat
		goto fi_velocitat
		

vel1
		 
		movf comptador_velocitat,W
		xorlw .2;
		btfss STATUS, Z
		goto vel2
	    movf dada_rebuda,W
		;call putchar
		movf dada_rebuda,W
		movwf velocitat2
		call es_coma_velocitat
		goto fi_velocitat

vel2

		movf comptador_velocitat,W
		xorlw .3;
		btfss STATUS, Z
		goto vel3
	    movf dada_rebuda,W
	
		movf dada_rebuda,W
		movwf velocitat3
		call es_coma_velocitat
		goto fi_velocitat

vel3

		movf comptador_velocitat,W
		xorlw .4;
		btfss STATUS, Z
		goto vel4
	    movf dada_rebuda,W
		
		movf dada_rebuda,W
		movwf velocitat4
		goto fi_velocitat

vel4

		movf comptador_velocitat,W
		xorlw .5;
		btfss STATUS, Z
		goto vel5
	    movf dada_rebuda,W
	
		movf dada_rebuda,W
		movwf velocitat5
		call es_coma_velocitat
		goto fi_velocitat


vel5
	
		movf comptador_velocitat,W
		xorlw .6;
		btfss STATUS, Z
		goto fi_velocitat
	    movf dada_rebuda,W
		movwf velocitat6
		call es_coma_velocitat

    	movf pantalla,w
		xorlw 0x11
		btfss STATUS,Z	
		goto continuavelocitat


;		movlw 0x31
;		movwf velocitat1
;		movlw 0x35
;		movwf velocitat2
;		movlw 0x2E
;		movwf velocitat3
;		movlw 0x37
;		movwf velocitat4
;		movlw 0x31
;		movwf velocitat5
;		movlw 0x36
;		movwf velocitat6
		;ara hem de mirar si la velocitat ha de sortir en km/h o nusos
		movfw km
		xorlw .1
		btfss STATUS,Z
		goto escriu_velocitat_pantalla
		
		pagesel passar_nusos_a_km
		call passar_nusos_a_km
		PAGESEL $
;



escriu_velocitat_pantalla		
		movlw .1
		movwf velocitat_borrada
		banksel punter_sat_nivells
		movlw .155
		movwf punter_sat_nivells
		banksel proba
		;BORRARA______________
		call punter_pag1
		call escriu_velocitat_buida
		;BORRAR--------------------
		call punter_pag1
		call escriu_velocitat	
		goto fi_velocitat
continuavelocitat
		movf velocitat_borrada,W
		xorlw .1
		btfss STATUS,Z
		goto fi_velocitat
		clrf velocitat_borrada
		banksel punter_sat_nivells
		movlw .155
		movwf punter_sat_nivells
		banksel proba
		call punter_pag1
		call escriu_velocitat_buida	
;continua_dir4
		goto fi_velocitat
 
   fi_velocitat
	
       	return
  


estat34
		movf estat_anterior,W
		xorlw .34
		btfss STATUS, Z
		goto estat35	
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0_pag1
		movf dada_rebuda,W
		;call putchar

		movlw .35
        movwf estat_anterior
        goto fi_pag1 


;Aquest estat captura la direcci cap a on ens movem
estat35
 		
  		movf estat_anterior,W
		xorlw .35;
		btfss STATUS, Z
		goto estat36	
		;***aqui agafem els 5 digits corresponents a la DIRECCIO****
		call captura_direccio
		movf comptador_direccio,W
		xorlw .5
		btfss STATUS, Z
		goto fi_pag1

		movf proba,W
		xorlw .123
		btfss STATUS,Z
		goto continua_normal2
		movlw .37
        movwf estat_anterior
        movlw .0
        movwf comptador_direccio
		clrf proba
        goto fi_pag1  

continua_normal2


		movlw .36
        movwf estat_anterior
        movlw .0
        movwf comptador_direccio
        goto fi_pag1  	
 





es_coma_direccio
;Si hem rebut una coma i espervem un nmero es un error del GPS (bastant freqent),
;en aquest cas posem a  0  totes les variables de velocitat, ja que la informaci segurament
;ser falsa
		call hiha_coma
		movf es_coma,W
		xorlw .1;
		btfss STATUS, Z
		goto fi_es_coma_direccio
;emplena_velocitat_zeros
   		movlw 0x10
        movwf direccio1
		movwf direccio2
		movwf direccio3
		movwf direccio4
		movwf direccio5
		movlw .5
        movwf comptador_direccio
		movlw .123
		movwf proba
fi_es_coma_direccio
return


;Aqui entrem a la mquina d'estats que ens capturar la direcci en graus.
;comptador_direcci ens dir en quin estat ens trobem.
captura_direccio
		movf comptador_direccio,W 
 		addlw .1
 		movwf comptador_direccio
		movf comptador_direccio,W
		xorlw .1;
		btfss STATUS, Z
		goto dir1
		movf dada_rebuda,W
		movwf direccio1
		call es_coma_direccio
		goto fi_direccio


dir1
		movf comptador_direccio,W
		xorlw .2;
		btfss STATUS, Z
		goto dir2
	    movf dada_rebuda,W
		movwf direccio2
		call es_coma_direccio
		goto fi_direccio


dir2
		movf comptador_direccio,W
		xorlw .3;
		btfss STATUS, Z
		goto dir3
	    movf dada_rebuda,W
		movwf direccio3
		goto fi_direccio


dir3
		movf comptador_direccio,W
		xorlw .4;
		btfss STATUS, Z
		goto dir4
	    movf dada_rebuda,W
		movwf direccio4
		call es_coma_direccio
		goto fi_direccio

dir4
	
		movf comptador_direccio,W
		xorlw .5;
		btfss STATUS, Z
		goto fi_direccio
	    movf dada_rebuda,W
		movwf direccio5
	    call es_coma_direccio
;Mirem a quina pantalla ens trobem i si es a la 0
;escribim la direcci
		movf pantalla,w
		xorlw 0x10
		btfss STATUS,Z	
		goto continuaDireccio
		movlw .1
		movwf direccio_borrada
		banksel punter_sat_nivells
		movlw .186
		movwf punter_sat_nivells
		banksel proba
		call punter_pag1
		call escriu_direccio	
		goto fi_direccio
continuaDireccio
;si estem en un altre pantalla la variable direccio_borrada
;ens avisa de si l'hem de borrar o no
		movf direccio_borrada,W
		xorlw .1
		btfss STATUS,Z
		goto fi_direccio
		clrf direccio_borrada
		movlw .186
		movwf punter_sat_nivells
		banksel proba
		call punter_pag1
		call escriu_direccio_buida	
		goto fi_direccio
fi_direccio
     	return


estat36
		movf estat_anterior,W
		xorlw .36
		btfss STATUS, Z
		goto estat37	
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0_pag1
		movf dada_rebuda,W
		;call putchar
		movlw .37
        movwf estat_anterior
        goto fi_pag1 

;En aquest estat capturem la data
estat37		
  		movf estat_anterior,W
		xorlw .37;
		btfss STATUS, Z
		goto estat38	
		;***aqui agafem els 6 digits corresponents a la DATA****
		call captura_data
		movf comptador_data,W
		xorlw .6
		btfss STATUS, Z
		goto fi_pag1
		movlw .38
        movwf estat_anterior
        movlw .0
        movwf comptador_data
        goto fi_pag1 

;Captura data conte el diagrama d'estats que anir llegint la data
;la variables es guardar a comptador_data
captura_data
        movf comptador_data,W 
 		addlw .1
 		movwf comptador_data
		movf comptador_data,W
		xorlw .1;
		btfss STATUS, Z
		goto dat1
		movf dada_rebuda,W
		movwf data1
		goto fi_data

dat1
		movf comptador_data,W
		xorlw .2;
		btfss STATUS, Z
		goto dat2
	    movf dada_rebuda,W
		movwf data2
		;call es_coma_direccio
		goto fi_data


dat2
		movf comptador_data,W
		xorlw .3;
		btfss STATUS, Z
		goto dat3
	    movf dada_rebuda,W
		movwf data3
		goto fi_data


dat3
		movf comptador_data,W
		xorlw .4;
		btfss STATUS, Z
		goto dat4
	    movf dada_rebuda,W
		movwf data4
		goto fi_data
dat4
		movf comptador_data,W
		xorlw .5;
		btfss STATUS, Z
		goto dat5
	    movf dada_rebuda,W
		movwf data5
		goto fi_data

dat5
		movf comptador_data,W
		xorlw .6;
		btfss STATUS, Z
		goto fi_data
	    movf dada_rebuda,W
		movwf data6

;Mentre no estiguem a la pantalla 2, la data es mostrar sempre
		movf pantalla,w
		xorlw 0x12
		btfsc STATUS,Z	
		goto continuah2
		movlw .1
		movwf data_borrada
    	banksel punter_sat_nivells
		movlw .22
		movwf punter_sat_nivells
		banksel proba
		call punter_pag1
		call escriu_data
		goto fi_data
continuah2
;si som a la pantalla 2 consultarem data_borrada per saber si hem d'escriure
;blancs
		movf data_borrada,W
		xorlw .1
		btfss STATUS,Z
		goto fi_data
		clrf data_borrada
		banksel punter_sat_nivells
		movlw .22
		movwf punter_sat_nivells
		banksel proba
		call punter_pag1
		call escriu_data_buida
		goto fi_data
fi_data
		return

;Aqui tenim els valors de l'hora per com ja els hem llegit a la trama 
;GPMC, ens els saltem
estat38 		
    	movf estat_anterior,W
		xorlw .38
		btfss STATUS, Z
		goto estat39
		movf comptador_hora,W
		addlw .1
		movwf comptador_hora
		xorlw .6
		btfss STATUS, Z
        goto fi_pag1 
		movlw .39
        movwf estat_anterior
        movlw .0
        movwf comptador_hora
		goto fi_pag1 


estat39
		movf estat_anterior,W
		xorlw .39
		btfss STATUS, Z
		goto estat40	
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0_pag1
		movf dada_rebuda,W
		;call putchar
		movlw .40
        movwf estat_anterior
		clrf comptador_coordenada1
        goto fi_pag1 

;Aqui rebem els valors de la coordenada 1 pero com ja l'hem capturat en un altre trama
;ens ho saltem
estat40
    	movf estat_anterior,W
		xorlw .40
		btfss STATUS, Z
		goto estat41

		;***aqui passem els 9 digits corresponents a la coordenada1****
		movf comptador_coordenada1,W
		addlw .1
		movwf comptador_coordenada1
		xorlw .9
		btfss STATUS, Z
        goto fi_pag1 
		movlw .41
        movwf estat_anterior
        movlw .0
        movwf comptador_coordenada1
		goto fi_pag1 

estat41
		movf estat_anterior,W
		xorlw .41
		btfss STATUS, Z
		goto estat42	
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0_pag1
		movf dada_rebuda,W
		movlw .42
        movwf estat_anterior
		clrf proba
        goto fi_pag1 


;Aqui rebem el valor de la orientaci Nord o Sud pero com ja l'hem capturat 
;en un altre trama ens la saltem
estat42
    	movf estat_anterior,W
		xorlw .42
		btfss STATUS, Z
		goto estat43
;Aprofitem  la variable proba per no gastar ms memoria
		movf proba,W
		addlw .1
		movwf proba
		xorlw .1
		btfss STATUS, Z
        goto fi_pag1 
		movlw .43
        movwf estat_anterior
        clrf proba
		goto fi_pag1 


estat43
		movf estat_anterior,W
		xorlw .43
		btfss STATUS, Z
		goto estat44	
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0_pag1
		movf dada_rebuda,W
		movlw .44
        movwf estat_anterior
		clrf proba
        goto fi_pag1 

;Aqui rebem els valors de la coordenada 2 pero com ja l'hem capturat en un altre trama
;ens ho saltem
estat44
    	movf estat_anterior,W
		xorlw .44
		btfss STATUS, Z
		goto estat45
		movf proba,W
		addlw .1
		movwf proba
		xorlw .10
		btfss STATUS, Z
        goto fi_pag1 
		movlw .45
        movwf estat_anterior
        clrf proba
		goto fi_pag1 
estat45
		movf estat_anterior,W
		xorlw .45
		btfss STATUS, Z
		goto estat46	
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0_pag1
		movf dada_rebuda,W
		;call putchar
		movlw .46
        movwf estat_anterior
		clrf proba
        goto fi_pag1 

;Aqui rebem el valor de la orientaci Est o Oest pero com ja l'hem capturat 
;en un altre trama ens la saltem
estat46
    	movf estat_anterior,W
		xorlw .46
		btfss STATUS, Z
		goto estat47
;***Aprofitem  la variable proba per no gastar ms memoria
		movf proba,W
		addlw .1
		movwf proba
		xorlw .1
		btfss STATUS, Z
        goto fi_pag1 
		movlw .47
        movwf estat_anterior
        clrf proba
		goto fi_pag1 

estat47
		movf estat_anterior,W
		xorlw .47
		btfss STATUS, Z
		goto estat48	
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0_pag1
		movf dada_rebuda,W
		;call putchar
		movlw .48
        movwf estat_anterior
		clrf proba
        goto fi_pag1 


;Aqui ens saltem una altre dada redundant, anomenada fix quality
estat48
    	movf estat_anterior,W
		xorlw .48
		btfss STATUS, Z
		goto estat49
;***Aprofitem  la variable proba per no gastar ms memoria
		movf proba,W
		addlw .1
		movwf proba
		xorlw .1
		btfss STATUS, Z
        goto fi_pag1 
		movlw .49
        movwf estat_anterior
        clrf proba
		goto fi_pag1 

estat49
		movf estat_anterior,W
		xorlw .49
		btfss STATUS, Z
		goto estat50	
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0_pag1
		movf dada_rebuda,W
		movlw .50
        movwf estat_anterior	
		clrf proba
        goto fi_pag1 

;Aqui capturem el nombre de satlits
estat50		
  		movf estat_anterior,W
		xorlw .50;
		btfss STATUS, Z
		goto estat51	
;***aqui agafem els 2 digits corresponents al numero de satelits***
		call captura_sat
		movf proba,W
		xorlw .2
		btfss STATUS, Z
		goto fi_pag1
		movlw .51
        movwf estat_anterior
		clrf proba
        goto fi_pag1
 
;En aquesta petita mquina de 2 estats capturarem els digits que ens diran
;a quants satlits estem conectats, proba fa de comptador
 captura_sat
 		movf proba,W 
 		addlw .1
 		movwf proba
		xorlw .1;
		btfss STATUS, Z
		goto sat1
		movf dada_rebuda,W
		movwf satelit2
		goto fi_sat
		
sat1

		movf proba,W
		xorlw .2;
		btfss STATUS, Z
		goto fi_sat
		movf dada_rebuda,W
		movwf satelit1
;Mentre no estiguem a la pantalla 2 hem de mostrar el nombre
;de satlits
		movf pantalla,w
		xorlw 0x12
		btfsc STATUS,Z	
		goto continuaSat
		movlw .1
		movwf num_satelits_borrats
		banksel punter_sat_nivells
		movlw .210
		movwf punter_sat_nivells
		banksel proba
		call punter_pag1
		call escriu_satelit	
		goto fi_sat
continuaSat
		movf num_satelits_borrats,W
		xorlw .1
		btfss STATUS,Z
		goto fi_sat
		clrf num_satelits_borrats
		banksel punter_sat_nivells
		movlw .210
		movwf punter_sat_nivells
		banksel proba
		call punter_pag1
		call escriu_satelit_buida	
		goto fi_sat
fi_sat
return


estat51
		movf estat_anterior,W
		xorlw .51
		btfss STATUS, Z
		goto estat52			
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto torna_estat0_pag1
		movf dada_rebuda,W
		movlw .52
        movwf estat_anterior
		clrf proba
        goto fi_pag1 

estat52
;No avanarem d'estat fins trobar la segent coma, ho farem aix perqu
;la dada que trobem entremig es de llargada variable.
		movf estat_anterior,W
		xorlw .52
		btfss STATUS, Z
		goto estat53	
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfss STATUS, Z
		goto fi_pag1
		movlw .53
        movwf estat_anterior
;preparem les variables per el prxim estat
		clrf proba
		clrf comptador_altura
		clrf altura1
		clrf altura2
		clrf altura3
		clrf altura4
		clrf altura5
		clrf altura6	
        goto fi_pag1 

;Arreclem els salts cap a altres pgines de la memria
torna_estat0_pag1
pagesel torna_estat0_pag2
goto torna_estat0_pag2

fi_pag1
pagesel fi_pag2
goto fi_pag2

estat54
pagesel estat54_pag2
goto estat54_pag2

estat53
pagesel estat53_pag2
goto estat53_pag2

;******************************************************
;************* CANVI DE PGINA*************************
;******************************************************

;Ens situem a la segent pgina de codi, la 2.
ORG 0x1000

;Un punter que coloca el cursor a la posici punter_sat_nivells
punter_pag2
	call status_check_pag2
	banksel punter_sat_nivells
	movfw punter_sat_nivells
	banksel TEMP
	movwf TEMP
	call envia_dada_pag2
	call status_check_pag2
	movlw 0x00
	banksel TEMP
	movwf TEMP
	call envia_dada_pag2
	call status_check_pag2  
	banksel TEMP
	movlw 0x24
	movwf TEMP
	call envia_comanda_pag2
	call status_check_pag2
return

;;Aquesta subrutina agafa les variables valor1 i valor2, treu els 4 bits de ms pes,
;;rota 4 vegades valor2 i fa una OR amb valor1,el resultat queda a W.
;;Ex: valor1=0x34 valor2=0x31 => W= 0x14
;passa_desenes_i_unitats_a_un
;	banksel valor1
;	movfw valor1
;	andlw 0x0F
;	movwf valor1
;;ja hem borrat la part alta de valor1, fem el mateix per valor2
;	movfw valor2
;	andlw 0x0F
;	movwf valor2	
;;rotem valor2 4 cops a travs del carry
;	bcf STATUS,C
;	rlf valor2,1	
;	rlf valor2,1
;	rlf valor2,1
;	rlf valor2,1
;;ara queda suma els valors
;	movfw valor2
;	iorwf valor1,0
;return



;Escribim la altura per pantalla, vigilant cada carcter
;doncs podem trobar una coma i l'hem de convertir al mapa de 
;carcters del nostre LCD
escriu_altura

	banksel TEMP

	call status_check_pag2
	movlw 0x21
	movwf TEMP
	call envia_dada_pag2
	call status_check_pag2
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag2

	call status_check_pag2
	movlw 0x4C
	movwf TEMP
	call envia_dada_pag2
	call status_check_pag2
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag2

	call status_check_pag2
	movlw 0x54
	movwf TEMP
	call envia_dada_pag2
	call status_check_pag2
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag2

	call status_check_pag2
	movlw 0x55
	movwf TEMP
	call envia_dada_pag2
	call status_check_pag2
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag2

	call status_check_pag2
	movlw 0x52
	movwf TEMP
	call envia_dada_pag2
	call status_check_pag2
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag2

	call status_check_pag2
	movlw 0x41
	movwf TEMP
	call envia_dada_pag2
	call status_check_pag2
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag2

	call status_check_pag2
	movlw 0x00
	movwf TEMP
	call envia_dada_pag2
	call status_check_pag2
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag2

	call status_check_pag2
	movf altura1,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP

	xorlw 0x1E
	btfss STATUS,Z
	goto altura1_punt
	movlw 0x0E
	movwf TEMP
altura1_punt
	call envia_dada_pag2
	call status_check_pag2
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag2	

	call status_check_pag2
	movf altura2,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP

	xorlw 0x1E
	btfss STATUS,Z
	goto altura2_punt
	movlw 0x0E
	movwf TEMP
altura2_punt

	call envia_dada_pag2
	call status_check_pag2
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag2	
	
	call status_check_pag2
	movf altura3,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP

	xorlw 0x1E
	btfss STATUS,Z
	goto altura3_punt
	movlw 0x0E
	movwf TEMP
altura3_punt

	call envia_dada_pag2
	call status_check_pag2
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag2	

	call status_check_pag2
	movf altura4,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP

	xorlw 0x1E
	btfss STATUS,Z
	goto altura4_punt
	movlw 0x0E
	movwf TEMP
altura4_punt

	call envia_dada_pag2
	call status_check_pag2
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag2	

	call status_check_pag2
	movf altura5,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP

	xorlw 0x1E
	btfss STATUS,Z
	goto altura5_punt
	movlw 0x0E
	movwf TEMP
altura5_punt

	call envia_dada_pag2
	call status_check_pag2
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag2	

	call status_check_pag2
	movf altura6,w
	andlw 0x0F
	iorlw 0x10
	movwf TEMP

	xorlw 0x1E
	btfss STATUS,Z
	goto altura6_punt
	movlw 0x0E
	movwf TEMP
altura6_punt

	call envia_dada_pag2
	call status_check_pag2
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag2	

return

;Agafem l'altitud, t com a mnim 3 digits, per en pot tenir 6.
;Anirem capturant els dgits fins arribar a una coma.
estat53_pag2
		movf estat_anterior,W
		xorlw .53;
		btfss STATUS, Z
		goto estat54_pag2
;Aqui agafem els 3,4,5 o 6 digits corresponents a l'altura, fins que trobem una coma
		movf dada_rebuda,W
		xorlw ',' ; Comparem el valor de W amb una lletra, Si es igual el flag de Z=1
		btfsc STATUS, Z
		goto acaba_altura
		call captura_altura
		goto fi_pag2

;Escriurem la altura a la pantalla 0x11, altrament la borrem
acaba_altura
		movlw .0
        movwf estat_anterior
		banksel pantalla
		movf pantalla,w
		xorlw 0x11
		btfss STATUS,Z	
		goto continuaAlt
		movlw .1
		movwf altura_borrada
		banksel punter_sat_nivells
		movlw .128
		movwf punter_sat_nivells
		banksel proba
		call punter_pag2
		call escriu_altura
		clrf comptador_altura
		clrf proba
		goto fi_pag2
;Si no som a la pantalla que toca comprobarem si hem de borrar els caracters
;que ocupava.
continuaAlt
		movf altura_borrada,W
		xorlw .1
		btfss STATUS,Z
		goto fi_pag2
		clrf altura_borrada
		banksel punter_sat_nivells
		movlw .128
		movwf punter_sat_nivells
		banksel proba
		call punter_pag2
		;call escriu_altura_buida	
		clrf comptador_altura
		clrf proba
        goto fi_pag2

;Creem una mquina d'estats per capturar l'altura
captura_altura
	movf comptador_altura,W
	addlw .1
	movwf comptador_altura
	xorlw .1
	btfss STATUS, Z
	goto alt1
	movf dada_rebuda,W
	movwf altura1
	goto acaba_altitud
		
alt1
	movf comptador_altura,W
	xorlw .2
	btfss STATUS, Z
	goto alt2
	movf dada_rebuda,W
	movwf altura2
	goto acaba_altitud

alt2
	movf comptador_altura,W
	xorlw .3
	btfss STATUS, Z
	goto alt3
	movf dada_rebuda,W
	movwf altura3
	goto acaba_altitud
alt3
	movf comptador_altura,W
	xorlw .4
	btfss STATUS, Z
	goto alt4
	movf dada_rebuda,W
	movwf altura4
	goto acaba_altitud
alt4
	movf comptador_altura,W
	xorlw .5
	btfss STATUS, Z
	goto alt5
	movf dada_rebuda,W
	movwf altura5
	goto acaba_altitud
alt5
	movf comptador_altura,W
	xorlw .6
	btfss STATUS, Z
	goto acaba_altitud
	movf dada_rebuda,W
	movwf altura6
	goto acaba_altitud

acaba_altitud
return



;Idntic al envia_comanda de la pgina 0, per adaptat a la 2
envia_comanda_pag2
;Per enviar una comanda activarem aquests senyals de control WR=L i C/D=H
	call status_check_pag2
	banksel TEMP
	bsf C_D
	bsf WR
	bsf R_D
;movem la dada al portB
	movf TEMP,w
	movwf PORTB
;activem l'escriptura de comanda
	bcf WR
	bcf C_E
	nop
	nop
	nop
	nop
	nop
	nop
	bsf WR
	bsf C_E
return

;Idntic al envia_comanda de la pgina 0, per adaptat a la 2
envia_dada_pag2
;Envia una dada pel portB
	call status_check_pag2
;Per enviar una dada s'han de tenir activat WR=L, C/D=L
	banksel TEMP
	bsf C_D
	bsf R_D
	bsf WR
;coloquem la dada que tenim a W al port B
	movf TEMP,w
	movwf PORTB
;activem la escriptura
	bcf WR
	bcf C_D
	bcf C_E
	nop 
	nop
	nop
	nop
	bsf WR
	bsf C_D
	bsf C_E
return

;Idntic al envia_comanda de la pgina 0, per adaptat a la 2
status_check_pag2
;l'Status_check es una comprobaci que fem per saber si l'LCD esta llest per
;rebre noves dades. Es tracta de comprobar si STA0 i STA1 estan a 1, Aquesta paraula
;d'estat la rebem pel portB, activant RD->L CE->L WR->H C/D->H

;Canviem de Bank i posem el portB com a entrada
	banksel TEMP
	bsf STATUS,RP0
	movlw 0xFF
	movwf TRISB
;Tornem al Bank 0
	bcf STATUS,RP0

;Activem les senyals
	bsf WR
	bsf C_D
	bcf R_D
	bcf C_E
refresca_pag2	
	nop
	nop 
	btfss PORTB,0
	goto refresca_pag2	
	btfss PORTB,1
	goto refresca_pag2	
	nop
	nop
	nop
;cambiem el valors dels senyals de control
	bsf C_E
	bcf C_D
;tornem a configurar PORTB com a sortida
	bsf STATUS,RP0
	clrf TRISB
	bcf STATUS,RP0	
return

;Reescriu els caracters de l'altura amb smbols blancs
escriu_altura_buida	
	movlw d'16'
	movwf proba
Bucle_altura	
	call status_check_pag2
	movlw 0x00
	movwf TEMP
	call envia_dada_pag2
	call status_check_pag2
	movlw 0xC0
	movwf TEMP
	call envia_comanda_pag2
	decfsz proba,1
	goto Bucle_altura
return


;Aquesta subrutina s un mquina d'estats enumerada amb la variable part, que assigna
;tant l'identificador de satlit com el seu nivell de senyal.
assigna_nivells
	banksel part
	movfw part
	xorlw .0
MASSIGNA_NIVELLS proba_nivell_2,id12
proba_nivell_2
	banksel part
	movfw part
	xorlw .1
MASSIGNA_NIVELLS proba_nivell_3,id11
proba_nivell_3
banksel part
	movfw part
	xorlw .2
MASSIGNA_NIVELLS proba_nivell_4,senyal1
proba_nivell_4
banksel part
	movfw part
	xorlw .3
MASSIGNA_NIVELLS proba_nivell_5,id22
proba_nivell_5
banksel part
	movfw part
	xorlw .4
MASSIGNA_NIVELLS proba_nivell_6,id21
proba_nivell_6
	banksel part
	movfw part
	xorlw .5
MASSIGNA_NIVELLS proba_nivell_7,senyal2
proba_nivell_7
	banksel part
	movfw part
	xorlw .6
MASSIGNA_NIVELLS proba_nivell_8,id32
proba_nivell_8
	banksel part
	movfw part
	xorlw .7
MASSIGNA_NIVELLS proba_nivell_9,id31
proba_nivell_9
	banksel part
	movfw part
	xorlw .8
MASSIGNA_NIVELLS proba_nivell_10,senyal3
proba_nivell_10
	banksel part
	movfw part
	xorlw .9
MASSIGNA_NIVELLS proba_nivell_11,id42
proba_nivell_11
	banksel part
	movfw part
	xorlw .10
MASSIGNA_NIVELLS proba_nivell_12,id41
proba_nivell_12
	banksel part
	movfw part
	xorlw .11
MASSIGNA_NIVELLS proba_nivell_13,senyal4
proba_nivell_13
	banksel part
	movfw part
	xorlw .12
MASSIGNA_NIVELLS proba_nivell_14,id52
proba_nivell_14
	banksel part
	movfw part
	xorlw .13
MASSIGNA_NIVELLS proba_nivell_15,id51
proba_nivell_15
	banksel part
	movfw part
	xorlw .14
MASSIGNA_NIVELLS proba_nivell_16,senyal5
proba_nivell_16
	banksel part
	movfw part
	xorlw .15
MASSIGNA_NIVELLS proba_nivell_17,id62
proba_nivell_17	
	banksel part
	movfw part
	xorlw .16
MASSIGNA_NIVELLS proba_nivell_18,id61
proba_nivell_18
	banksel part
	movfw part
	xorlw .17
MASSIGNA_NIVELLS proba_nivell_19,senyal6
proba_nivell_19
	banksel part
	movfw part
	xorlw .18
MASSIGNA_NIVELLS proba_nivell_20,id72
proba_nivell_20
	banksel part
	movfw part
	xorlw .19
MASSIGNA_NIVELLS proba_nivell_21,id71
proba_nivell_21
	banksel part
	movfw part
	xorlw .20
MASSIGNA_NIVELLS proba_nivell_22,senyal7
proba_nivell_22
	banksel part
	movfw part
	xorlw .21
MASSIGNA_NIVELLS proba_nivell_23,id82
proba_nivell_23
	banksel part
	movfw part
	xorlw .22
MASSIGNA_NIVELLS proba_nivell_24,id81
proba_nivell_24
	banksel part
	movfw part
	xorlw .23
MASSIGNA_NIVELLS proba_nivell_25,senyal8
proba_nivell_25
	banksel part
	movfw part
	xorlw .24
MASSIGNA_NIVELLS proba_nivell_26,id92
proba_nivell_26
	banksel part
	movfw part
	xorlw .25
MASSIGNA_NIVELLS proba_nivell_27,id91
proba_nivell_27
	banksel part
	movfw part
	xorlw .26
MASSIGNA_NIVELLS proba_nivell_28,senyal9
proba_nivell_28
	banksel part
	movfw part
	xorlw .27
MASSIGNA_NIVELLS proba_nivell_29,id102
proba_nivell_29
	banksel part
	movfw part
	xorlw .28
MASSIGNA_NIVELLS proba_nivell_30,id101
proba_nivell_30
	banksel part
	movfw part
	xorlw .29
MASSIGNA_NIVELLS proba_nivell_31,senyal10
proba_nivell_31
	banksel part
	movfw part
	xorlw .30
MASSIGNA_NIVELLS proba_nivell_32,id112
proba_nivell_32
	banksel part
	movfw part
	xorlw .31
MASSIGNA_NIVELLS proba_nivell_33,id111
proba_nivell_33
	banksel part
	movfw part
	xorlw .32
MASSIGNA_NIVELLS proba_nivell_34,senyal11
proba_nivell_34
	banksel part
	movfw part
	xorlw .33
MASSIGNA_NIVELLS proba_nivell_35,id122
proba_nivell_35
	banksel part
	movfw part
	xorlw .34
MASSIGNA_NIVELLS proba_nivell_36,id121
proba_nivell_36
	banksel part
	movfw part
	xorlw .35
MASSIGNA_NIVELLS proba_nivell_37,senyal12
proba_nivell_37
fi_assigna_nivells
return

 
;En aquests estat capturarem el nivell de senyal, evitant les comes i 
;tornant a l'inici en rebre un caracter $
estat54_pag2
	banksel estat_anterior
	movf estat_anterior,W
	xorlw .54;
	btfss STATUS,Z
	goto estat55

	banksel dada_rebuda
	movfw dada_rebuda
	xorlw ','
	btfsc STATUS,Z
	goto fi_pag2
	
	banksel dada_rebuda
	movfw dada_rebuda
	xorlw '$'
	btfsc STATUS,Z
	goto torna_estat1
;Assignem el nivell de senyal i comprovem que ja els hem agafat tots per passar a l'estat segent
	call assigna_nivells
	banksel part
	movfw part
	xorlw .36
	btfss STATUS,Z
	goto fi_pag2
	clrf part
	movlw .55
	banksel estat_anterior
	movwf estat_anterior
	goto fi_pag2

torna_estat1
	banksel estat_anterior
	movlw .1
	movwf estat_anterior	
	goto fi_pag2


;Aquesta subrutina passa el valor que tenima le variables velocitat1...velocitat6
;que estan en nusos a km/h
passar_nusos_a_km
;passa els caracters a eners
	call passar_ASCII_a_enter
;Ho multiploca per 1,8
	call multiplicar_per_u_coma8
;ara tenim el resultat a vel_previaX
;tornem a posar la coma alla on hagi de ser
	call suma_comes
;passem a ascii 
	call passa_enter_a_Ascii_lcd
return

;Aquesta subrutina multiplica el que tinguem al registre DEN i NUM i retorna
;el resultat a centenes, desenes i unitats.
;Fem servir les variables DEN i NUM on hi hauran els valor a multiplicar
;a la variable resultat quedar el resultat,
;desprs passarem a separar els digits de la multiplicaci
multiplicar
	banksel resultat
	clrf resultat
;inici del bucle de la multiplicacio
continua_multiplicant
	movfw DEN
	addwf resultat,1
	decfsz NUM,1
	goto continua_multiplicant
	movfw resultat
	call passar_a_BCD
return


;Es tracta de agafar el nombre que guardem a W a bcd, guardant els seus valor
;a unitats, desenes i centenes
passar_a_BCD
	banksel centenes	
    clrf centenes 
    clrf desenes 
    movwf unitats 
continua_unitats 
	movlw .10
 	subwf unitats,W
 	btfss STATUS,C
    goto continua_desenes
    movwf unitats
    incf desenes, F
    goto continua_unitats
continua_desenes
    movlw .10
    subwf desenes,W
    btfss STATUS,C
    goto fi_ajusta_bcd
    movwf desenes
    incf centenes,F
    goto continua_desenes
fi_ajusta_bcd
return

;A l'hora de fer sumes i restes s molt incmode traballar amb valors ASCII
;per tant els passem a enters, vigilant sempre de no modificar la coma
passar_ASCII_a_enter
	banksel velocitat3
	movfw velocitat1
	xorlw 0x2E
	btfsc STATUS,Z
	goto passa_enter_2
	movfw velocitat1
	andlw 0x0F
	movwf velocitat1

passa_enter_2
	movfw velocitat2
	xorlw 0x2E
	btfsc STATUS,Z
	goto passa_enter_3
	movfw velocitat2
	andlw 0x0F
	movwf velocitat2

passa_enter_3
	movfw velocitat3
	xorlw 0x2E
	btfsc STATUS,Z
	goto passa_enter_4
	movfw velocitat3
	andlw 0x0F
	movwf velocitat3

passa_enter_4
	movfw velocitat4
	xorlw 0x2E
	btfsc STATUS,Z
	goto passa_enter_5
	movfw velocitat4
	andlw 0x0F
	movwf velocitat4

passa_enter_5
	movfw velocitat5
	xorlw 0x2E
	btfsc STATUS,Z
	goto passa_enter_6
	movfw velocitat5
	andlw 0x0F
	movwf velocitat5

passa_enter_6
	movfw velocitat6
	xorlw 0x2E
	btfsc STATUS,Z
	goto fi_passar_ascii_a_enter
	movfw velocitat6
	andlw 0x0F
	movwf velocitat6

fi_passar_ascii_a_enter
return

;Aquesta subrutina multiplica el nombre format per les variables
;velocitat6....velocitat1 per 1,8 que es el valor pel que s'ha de 
;multiplicar per passar de nusos a km/h
multiplicar_per_u_coma8
	banksel NUM
;netejem els registres
	clrf vel_temp0
	clrf vel_temp1
	clrf vel_temp2
	clrf vel_temp3
	clrf vel_temp4
	clrf vel_temp5
	clrf vel_temp6
	clrf vel_temp7
	clrf vel_previa0
	clrf vel_previa1
	clrf vel_previa2
	clrf vel_previa3
	clrf vel_previa4
	clrf vel_previa5
	clrf vel_previa6
	clrf vel_previa7
;La multiplicaci es far en 2 parts, primer multiplicar les velocitats 
;per 8, els resultat es podran veure a 
;ms endavant li sumarem la mateixa velocitat desplaada en 1.
;Posem un 8 al numerador
	movlw .8
	banksel NUM
;Si velocitat6 no es una coma multipliquem....
	movwf NUM
	banksel velocitat6
	movfw velocitat6
	xorlw 0x2E
	btfsc STATUS,Z
	goto anar_velocitat5_coma

;posem el valor de la velocitat a DEN i multipliquem
	banksel velocitat6
	movfw velocitat6

	banksel DEN
	movwf DEN

	call multiplicar
	banksel unitats

	movfw unitats
	movwf vel_temp6

	movfw desenes
	movwf carry_anterior
;S'ha fet la primera multiplicaci
	goto anar_velocitat5

anar_velocitat5_coma
 	movlw 0x2E
	banksel vel_temp6
	movwf vel_temp6
anar_velocitat5
	movlw .8
	movwf NUM
	banksel velocitat5
	movfw velocitat5
	xorlw 0x2E
	btfsc STATUS,Z
	goto anar_velocitat4_coma
	
	banksel velocitat5
	movfw velocitat5

	banksel DEN
	movwf DEN

	call multiplicar
	banksel unitats

; vel_tempx guardar temporalment el valor de les desenes que hagi provocat la multiplicacio
	movfw desenes
	movwf vel_temp5

	movfw unitats
	addwf carry_anterior,0

; aqui tenim la suma del resultat ms el carry, ara hem de vigilar que no passi de 9
	call passar_a_BCD
	movfw vel_temp5

	addwf desenes,0
	movwf carry_anterior

	movfw unitats
	movwf vel_temp5 

	goto anar_velocitat4

;tenim a carry_anterior el resultat del carry que li haurem de sumar a les unitats
;que ens doni la multiplicacio
;i repetirem el procs per cada dgit de la velocitat
anar_velocitat4_coma
	movlw 0x2E
	banksel vel_temp5
	movwf vel_temp5
anar_velocitat4
	movlw .8
	banksel NUM
	movwf NUM
	banksel velocitat4
	movfw velocitat4
	xorlw 0x2E
	btfsc STATUS,Z
	goto anar_velocitat3_coma

	banksel velocitat4
	movfw velocitat4

	banksel DEN
	movwf DEN

	call multiplicar
	banksel unitats

; vel_tempx guardar temporalment el valor de les desenes que hagi provocat la multiplicacio
	movfw desenes
	movwf vel_temp4
	
	movfw unitats
	addwf carry_anterior,0

; aqui tenim la suma del resultat ms el carry, ara hem de vigilar que no passi de 9
	call passar_a_BCD
	movfw vel_temp4

	addwf desenes,0
	movwf carry_anterior

	movfw unitats
	movwf vel_temp4 

	goto anar_velocitat3



anar_velocitat3_coma
	movlw 0x2E
	banksel vel_temp4
	movwf vel_temp4

anar_velocitat3
	movlw .8
	banksel NUM
	movwf NUM
	banksel velocitat3
	movfw velocitat3
	xorlw 0x2E
	btfsc STATUS,Z
	goto anar_velocitat2_coma

	banksel velocitat3
	movfw velocitat3

	banksel DEN
	movwf DEN

	call multiplicar
	banksel unitats

; vel_tempx guardar temporalment el valor de les desenes que hagi provocat la multiplicacio
	movfw desenes
	movwf vel_temp3

	movfw unitats
	addwf carry_anterior,0

; aqui tenim la suma del resultat ms el carry, ara hem de vigilar que no passi de 9
	call passar_a_BCD	
	movfw vel_temp3
	
	addwf desenes,0
	movwf carry_anterior

	movfw unitats
	movwf vel_temp3

	goto anar_velocitat2


anar_velocitat2_coma
	movlw 0x2E
	banksel vel_temp3
	movwf vel_temp3

anar_velocitat2
	movlw .8
	banksel NUM
	movwf NUM
	banksel velocitat2
	movfw velocitat2
	xorlw 0x2E
	btfsc STATUS,Z
	goto anar_velocitat1_coma

	banksel velocitat2
	movfw velocitat2

	banksel DEN
	movwf DEN

	call multiplicar
	banksel unitats

; vel_tempx guardar temporalment el valor de les desenes que hagi provocat la multiplicacio
	movfw desenes
	movwf vel_temp2

	movfw unitats
	addwf carry_anterior,0

; aqui tenim la suma del resultat ms el carry, ara hem de vigilar que no passi de 9
	call passar_a_BCD
	movfw vel_temp2
;borrar la segent linia
	addwf desenes,0
	movwf carry_anterior

	movfw unitats
	movwf vel_temp2 

	goto anar_velocitat1


anar_velocitat1_coma
	banksel vel_temp3
	movlw 0x2E
	movwf vel_temp2

anar_velocitat1
	movlw .8
	banksel NUM
	movwf NUM
	banksel velocitat1
	movfw velocitat1
	banksel DEN
	movwf DEN
	call multiplicar
	banksel unitats

; vel_tempx guardar temporalment el valor de les desenes que hagi provocat la multiplicacio
	movfw desenes
	movwf vel_temp1

	movfw unitats	
	addwf carry_anterior,0

; aqui tenim la suma del resultat ms el carry, ara hem de vigilar que no passi de 9
	call passar_a_BCD
	movfw vel_temp1
	
	addwf desenes,0
	movwf vel_temp0

	movfw unitats
	movwf vel_temp1 
	

;Ja tenim a vel_tempx el valor de la velocitat en nusos x8, ara li 
;sumem la mateixa velocitat original en nusos desplaat en 1 cap a l'esquerra.
;deixarem el resultat a vel_previaX
	banksel vel_temp6
	movfw vel_temp6
	movwf vel_previa7
;Quan detectem una coma, cridarem una subrutina per eliminar-la,
;per ens guardarem la seva posici 
;	movlw .1
;	movwf coma_temp_no_final
	movfw vel_temp5
	xorlw 0x2E
	btfsc STATUS,Z
	call es_coma_vel_temp1
	;continua_es_coma_vel_temp1
	movlw .1
	movwf coma_vel_no_final
	banksel velocitat6
	movfw velocitat6
	xorlw 0x2E
	btfsc STATUS,Z
	call es_coma_velocitatx
	banksel velocitat6
	movfw velocitat6
	banksel vel_temp6
	addwf vel_temp5,0
	call passar_a_BCD
	banksel unitats
	movfw unitats
	movwf vel_previa6

;repetim el procs per tots els dgits	
;	movlw .2
	banksel DEN
;	movwf coma_temp_no_final
	movfw vel_temp4
	xorlw 0x2E
	btfsc STATUS,Z
	call es_coma_vel_temp1
	movlw .2
	banksel DEN
	movwf coma_vel_no_final
	banksel velocitat5
	movfw velocitat5
	xorlw 0x2E
	btfsc STATUS,Z
	call es_coma_velocitatx
	banksel velocitat5
	movfw velocitat5
	banksel desenes
	addwf desenes,0
	addwf vel_temp4,0
	call passar_a_BCD
	movfw unitats
	movwf vel_previa5
	
	banksel DEN
;movlw .3
;movwf coma_temp_no_final
	movfw vel_temp3
	xorlw 0x2E
	btfsc STATUS,Z
	call es_coma_vel_temp1
	movlw .3
	movwf coma_vel_no_final
	banksel velocitat4
	movfw velocitat4
	xorlw 0x2E
	btfsc STATUS,Z
	call es_coma_velocitatx
	banksel velocitat4
	movfw velocitat4
	banksel desenes
	addwf desenes,0
	addwf vel_temp3,0
	call passar_a_BCD
	movfw unitats
	movwf vel_previa4
	
	banksel vel_temp2
;movlw .4
;movwf coma_temp_no_final
	movfw vel_temp2
	xorlw 0x2E
	btfsc STATUS,Z
	call es_coma_vel_temp1
	movlw .4
	banksel DEN
	movwf coma_vel_no_final
	banksel velocitat3
	movfw velocitat3
	xorlw 0x2E
	btfsc STATUS,Z
	call es_coma_velocitatx
	banksel velocitat3
	movfw velocitat3
	banksel DEN
	addwf desenes,0
	addwf vel_temp2,0
	call passar_a_BCD
	movfw unitats
	movwf vel_previa3
	
;aquest equival a l'ultim digit que es veu a la pantalla
	banksel DEN
;movlw .5
;movwf coma_temp_no_final
	movfw vel_temp1
	xorlw 0x2E
	btfsc STATUS,Z
	call es_coma_vel_temp1
	banksel DEN
	movlw .5
	movwf coma_vel_no_final
	banksel velocitat2
	movfw velocitat2
	xorlw 0x2E
	btfsc STATUS,Z
	call es_coma_velocitatx
	banksel velocitat2
	movfw velocitat2
	banksel desenes
	addwf desenes,0
	addwf vel_temp1,0
	call passar_a_BCD
	banksel unitats
	movfw unitats
	movwf vel_previa2


;	movlw .6
;	movwf coma_temp_no_final
	movfw vel_temp0
	xorlw 0x2E
	btfsc STATUS,Z
	call es_coma_vel_temp1
	banksel DEN
	movlw .6
	movwf coma_vel_no_final
	banksel velocitat1
	movfw velocitat1
	xorlw 0x2E
	btfsc STATUS,Z
	call es_coma_velocitatx
	banksel velocitat1
	movfw velocitat1
	banksel desenes
	addwf desenes,0
	addwf vel_temp0,0
	call passar_a_BCD
	banksel unitats
	movfw unitats
	movwf vel_previa1
	movfw desenes
	movwf vel_previa0
return


es_coma_velocitatx
;ens apuntem on est la coma de la velocitat i apretem els digits per formar un nou nombre sense coma
	banksel DEN
	movfw coma_vel_no_final
	movwf coma_vel
	
	xorlw .5
	btfsc STATUS,Z
	goto coma_a_5
	movfw coma_vel
	xorlw .4
	btfsc STATUS,Z
	goto coma_a_4
	movfw coma_vel
	xorlw .3
	btfsc STATUS,Z
	goto coma_a_3
	movfw coma_vel
	xorlw .2
	btfsc STATUS,Z
	goto coma_a_2
	movfw coma_vel
	xorlw .1
	btfsc STATUS,Z
	goto coma_a_1


coma_a_1
	banksel velocitat6
	movfw velocitat5
	movwf velocitat6

coma_a_2
	banksel velocitat6
	movfw velocitat4
	movwf velocitat5

coma_a_3
	banksel velocitat6
	movfw velocitat3
	movwf velocitat4

coma_a_4
	banksel velocitat6
	movfw velocitat2
	movwf velocitat3
	
coma_a_5
	banksel velocitat6
	movfw velocitat1
	movwf velocitat2
	clrf velocitat1

return

;Si som aqui es que em trobat una coma  a l'hora de fer una suma
;ara es tractar d'agafar vel_tempx i rotar els bytes cap a la dreta per fer desapareixer la coma
es_coma_vel_temp1
	movfw coma_vel_no_final
	movwf coma_temp
	
	xorlw .5
	btfsc STATUS,Z
	goto coma_temp_a_5
	movfw coma_temp
	xorlw .4
	btfsc STATUS,Z
	goto coma_temp_a_4
	movfw coma_temp
	xorlw .3
	btfsc STATUS,Z
	goto coma_temp_a_3
	movfw coma_temp
	xorlw .2
	btfsc STATUS,Z
	goto coma_temp_a_2
	movfw coma_temp
	xorlw .1
	btfsc STATUS,Z
	goto coma_temp_a_0


coma_temp_a_0
	movfw vel_temp5
	movwf vel_temp6
coma_temp_a_2	
	movfw vel_temp4
	movwf vel_temp5
coma_temp_a_3	
	movfw vel_temp3
	movwf vel_temp4
coma_temp_a_4	
	movfw vel_temp2
	movwf vel_temp3

coma_temp_a_5	
	movfw vel_temp1
	movwf vel_temp2

	movfw vel_temp0
	movwf vel_temp1
	clrf vel_temp0
return 

;Aquest mtode deixa a les variables velocitatx, la velocitat en km/h per passant el nmero
;que ara est escrit com a enter al format del mapa de carcters que fa servir l'LCD
passa_enter_a_Ascii_lcd
	banksel DEN	
	movfw vel_previa1
	banksel velocitat1
	movwf velocitat1

continua_ascii2
	banksel DEN 
	movfw vel_previa2
	banksel velocitat2
	movwf velocitat2

continua_ascii3
   banksel DEN
	movfw vel_previa3
    banksel velocitat3 
	movwf velocitat3

continua_ascii4
   banksel DEN
	movfw vel_previa4
    banksel velocitat4
	movwf velocitat4

continua_ascii5
    banksel DEN
	movfw vel_previa5
    banksel velocitat5
	movwf velocitat5

continua_ascii6
   banksel DEN
	movfw vel_previa6
	banksel velocitat6
	movwf velocitat6

fi_continua_ascii
return

;Aquest codi mira on estven posades les comes anteriorment i les afegeix al 
;resultat provisional vel_previaX
suma_comes
	banksel DEN
	movfw coma_vel
;tindrem a coma_vel el resultat un enter en la posicio on ha d'anar al coma
	movwf coma_vel
	xorlw .2
	btfsc STATUS,Z
	goto coma_al_2
	movfw coma_vel
	xorlw .3
	btfsc STATUS,Z
	goto coma_al_3
	movfw coma_vel
	xorlw .4
	btfsc STATUS,Z
	goto coma_al_4
	movfw coma_vel
	xorlw .5
	btfsc STATUS,Z
	goto coma_al_5
	movfw coma_vel
	xorlw .6
	btfsc STATUS,Z
	goto coma_al_6

coma_al_6
	movfw vel_previa2
	movwf TEMP1	
	;movlw 0x0E
	movlw 0x2E	
	movwf vel_previa2
	goto continua_coma_al_3
coma_al_5
	movfw vel_previa3
	movwf TEMP2	
	movlw 0x2E
	movwf vel_previa3
	goto continua_coma_al_4

coma_al_4
	movfw vel_previa4
	movwf TEMP1
	;movlw 0x0E
;	movwf vel_previa4	
	movlw 0x2E
	movwf vel_previa4
	goto continua_coma_al_5

coma_al_3
	movfw vel_previa5
	movwf TEMP2	
	movlw 0x2E 
	movwf vel_previa5
	goto continua_coma_al_6
coma_al_2
	movfw vel_previa6
	movwf TEMP1	
	movlw 0x2E
	movwf vel_previa6	
	movfw vel_previa7
	movwf TEMP2

	
	movfw TEMP1
	movwf vel_previa7

	movfw vel_previa2
	movwf TEMP1


	movfw TEMP2
	movwf vel_previa2
continua_coma_al_3
	movfw vel_previa3
	movwf TEMP2


	movfw TEMP1
	movwf vel_previa3
continua_coma_al_4
	banksel vel_previa4
	movfw vel_previa4
	movwf TEMP1


	movfw TEMP2
	movwf vel_previa4
continua_coma_al_5
	movfw vel_previa5
	movwf TEMP2


	movfw TEMP1
	movwf vel_previa5

continua_coma_al_6

	movfw vel_previa6
	movwf TEMP1

	movfw TEMP2
	movwf vel_previa6

	movfw vel_previa7
	movwf TEMP2

	movfw TEMP1
	movwf vel_previa7
fi_continua_coma
return

;Com que dibuixar les barres de nivells requerir 
;molta memoria de codi i no voldrem salts comencem a l'ultima pagina de codi
;Preparem el salts...
estat55
pagesel estat55_pag3
goto estat55_pag3

torna_estat0_pag2
pagesel torna_estat0_pag3
goto torna_estat0_pag3

fi_pag2
pagesel fi_pag3
goto fi_pag3

;******************************************************
;************* CANVI DE PGINA*************************
;******************************************************

ORG 0x1800

;Repliquem les comandes que sabem que utilitzarem i que ja han estat comentades
;a la pgina 0
envia_comanda_pag3
;Per enviar una comanda activarem aquests senyals de control WR=L i C/D=H
	call status_check_pag3
	banksel TEMP
	bsf C_D
	bsf WR
	bsf R_D
;movem la dada al portB
	movf TEMP,w
	movwf PORTB
;activem l'escriptura de comanda
	bcf WR
	bcf C_E
	nop
	nop
	nop
	nop
	nop
	nop
	bsf WR
	bsf C_E
return

envia_dada_pag3
;Envia una dada pel portB

	call status_check_pag3
;Per enviar una dada s'han de tenir activat WR=L, C/D=L
	banksel TEMP
	bsf C_D
	bsf R_D
	bsf WR
;coloquem la dada que tenim a W al port B
	movf TEMP,w
	movwf PORTB
;activem la escriptura
	bcf WR
	bcf C_D
	bcf C_E
	nop 
	nop
	nop
	nop
	bsf WR
	bsf C_D
	bsf C_E
return

status_check_pag3
;l'Status_check es una comprobaci que fem per saber si l'LCD esta llest per
;rebre noves dades. Es tracta de comprobar si STA0 i STA1 estan a 1, Aquesta paraula
;d'estat la rebem pel portB, activant RD->L CE->L WR->H C/D->H

;Canviem de Bank i posem el portB com a entrada
	banksel TEMP
	bsf STATUS,RP0
	movlw 0xFF
	movwf TRISB
;Tornem al Bank 0
	bcf STATUS,RP0

;Activem les senyals
	bsf WR
	bsf C_D
	bcf R_D
	bcf C_E
refresca_pag3	
	nop
	nop 
;llegim STA0 i STA1
	btfss PORTB,0
	goto refresca_pag3	

	btfss PORTB,1
	goto refresca_pag3	
	nop
	nop
	nop
;cambiem el valors dels senyals de control
	bsf C_E
	bcf C_D
;tornem a configurar PORTB com a sortida
	bsf STATUS,RP0
	clrf TRISB
	bcf STATUS,RP0	
return

;Un punter amb el parmetre d'entrada punter_sat_nivells que ens
;colocor el punter al LCD
punter_pag3
	call status_check_pag3
	banksel punter_sat_nivells
	movfw punter_sat_nivells
	banksel TEMP
	movwf TEMP
	call envia_dada_pag3
	call status_check_pag3
	movlw 0x00
	banksel TEMP
	movwf TEMP
	call envia_dada_pag3
	call status_check_pag3
	banksel TEMP
	movlw 0x24
	movwf TEMP
	call envia_comanda_pag3
	call status_check_pag3
return

;Aquesta subrutina escriu un carcter al LCD
;concretament el contigut de valor_sat_nivells
escriu_pag3
	call status_check_pag3
	banksel valor_sat_nivells
	movfw valor_sat_nivells
	banksel TEMP
	movwf TEMP
	call envia_dada_pag3
	call status_check_pag3
	movlw 0xC0
	banksel TEMP
	movwf TEMP
	call envia_comanda_pag3
return

;Neteja tots els carcters de la pantalla
neteja_pantalla_pag3
	movlw d'240'
	banksel proba
	movwf proba
Bucle9	
	call status_check_pag3
	movlw 0x00
	banksel TEMP
	movwf TEMP
	call envia_dada_pag3
	call status_check_pag3
	movlw 0xC0
	banksel TEMP
	movwf TEMP
	call envia_comanda_pag3
	banksel proba
	decfsz proba,1
	goto Bucle9
return

;Escriu el smbol que hem creat a la pantalla
escriu_simbol
	call status_check_pag3
	movlw 0x80
	banksel TEMP
	movwf TEMP
	call envia_dada_pag3
	call status_check_pag3
	movlw 0xC0
	banksel TEMP
	movwf TEMP
	call envia_comanda_pag3
	call status_check_pag3
return

;En aquest estat ja hem agafat tot els caracters necessaris i ens diposem
;a dibuixarlos, sempre i quan etiguem a la pantalla 0x12
estat55_pag3
	banksel estat_anterior
	movf estat_anterior,W
	xorlw .55;
	btfss STATUS,Z
	goto torna_estat0_pag3

	banksel pantalla
	movf pantalla,w
	xorlw 0x12
	btfss STATUS,Z	
	goto borra_els_nivells
;netejem la pantalla
	banksel nivells_borrats
	movlw .1
	movwf nivells_borrats
	banksel punter_sat_nivells
	movlw .0
	movwf punter_sat_nivells
	call punter_pag3
	call neteja_pantalla_pag3

;estem a la pantalla 2 i volem veure les barres de senyal	
;Primer escribim l'identificador de senyal
	banksel punter_sat_nivells
	movlw .210
	movwf punter_sat_nivells
	call punter_pag3
	
	banksel valor_sat_nivells
	movfw id11
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
	
	banksel valor_sat_nivells
	movfw id12
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
;ja hem escrit l'ID del satelit, ara "dibuixarem" la barra
;Codi per el Satelit 1
	banksel senyal1
	movfw senyal1
	xorlw 0x37
	btfsc STATUS,Z
	goto n1_7
	movfw senyal1
	xorlw 0x36
	btfsc STATUS,Z
	goto n1_6
	movfw senyal1
	xorlw 0x35
	btfsc STATUS,Z
	goto n1_5
	movfw senyal1
	xorlw 0x34
	btfsc STATUS,Z
	goto n1_4
	movfw senyal1
	xorlw 0x33
	btfsc STATUS,Z
	goto n1_3
	movfw senyal1
	xorlw 0x32
	btfsc STATUS,Z
	goto n1_2
	movfw senyal1
	xorlw 0x31
	btfsc STATUS,Z
	goto n1_1
	goto seguent_satelit2

n1_7 	
	banksel punter_sat_nivells
	movlw .1
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n1_6 	
	banksel punter_sat_nivells
	movlw .31
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n1_5 	
	banksel punter_sat_nivells
	movlw .61
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n1_4 	
	banksel punter_sat_nivells
	movlw .91
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n1_3 	
	banksel punter_sat_nivells
	movlw .121
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n1_2 	
	banksel punter_sat_nivells
	movlw .151
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n1_1 	
	banksel punter_sat_nivells
	movlw .181
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol

;Repetirem el codi per cada satlit2

seguent_satelit2
	banksel punter_sat_nivells
	movlw .212
	movwf punter_sat_nivells
	call punter_pag3
	
	banksel valor_sat_nivells
	movfw id21
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
	
	banksel valor_sat_nivells
	movfw id22
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
;ja hem escrit l'ID del satelit, ara "dibuixarem" la barra
;Codi per el Satelit 1
banksel senyal1
	movfw senyal2
	xorlw 0x37
	btfsc STATUS,Z
	goto n2_7
	movfw senyal2
	xorlw 0x36
	btfsc STATUS,Z
	goto n2_6
	movfw senyal2
	xorlw 0x35
	btfsc STATUS,Z
	goto n2_5
	movfw senyal2
	xorlw 0x34
	btfsc STATUS,Z
	goto n2_4
	movfw senyal2
	xorlw 0x33
	btfsc STATUS,Z
	goto n2_3
	movfw senyal2
	xorlw 0x32
	btfsc STATUS,Z
	goto n2_2
	movfw senyal2
	xorlw 0x31
	btfsc STATUS,Z
	goto n2_1
	goto seguent_satelit3

n2_7 	
	banksel punter_sat_nivells
	movlw .3
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n2_6 	
	banksel punter_sat_nivells
	movlw .33
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n2_5 	
	banksel punter_sat_nivells
	movlw .63
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n2_4 	
	banksel punter_sat_nivells
	movlw .93
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n2_3 	
	banksel punter_sat_nivells
	movlw .123
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n2_2 	
	banksel punter_sat_nivells
	movlw .153
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n2_1 	
	banksel punter_sat_nivells
	movlw .183
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol

;Repetirem el codi per cada satlit3

seguent_satelit3

	banksel punter_sat_nivells
	movlw .214
	movwf punter_sat_nivells
	call punter_pag3
	
	banksel valor_sat_nivells
	movfw id31
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
	
	banksel valor_sat_nivells
	movfw id32
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3

banksel senyal1
	movfw senyal3
	xorlw 0x37
	btfsc STATUS,Z
	goto n3_7
	movfw senyal3
	xorlw 0x36
	btfsc STATUS,Z
	goto n3_6
	movfw senyal3
	xorlw 0x35
	btfsc STATUS,Z
	goto n3_5
	movfw senyal2
	xorlw 0x34
	btfsc STATUS,Z
	goto n3_4
	movfw senyal3
	xorlw 0x33
	btfsc STATUS,Z
	goto n3_3
	movfw senyal3
	xorlw 0x32
	btfsc STATUS,Z
	goto n3_2
	movfw senyal3
	xorlw 0x31
	btfsc STATUS,Z
	goto n3_1
	goto seguent_satelit4

n3_7 	
	banksel punter_sat_nivells
	movlw .5
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n3_6 	
	banksel punter_sat_nivells
	movlw .35
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n3_5 	
	banksel punter_sat_nivells
	movlw .65
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n3_4 	
	banksel punter_sat_nivells
	movlw .95
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n3_3 	
	banksel punter_sat_nivells
	movlw .125
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n3_2 	
	banksel punter_sat_nivells
	movlw .155
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n3_1 	
	banksel punter_sat_nivells
	movlw .185
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol

;Repetirem el codi per cada satlit4

seguent_satelit4
	banksel punter_sat_nivells
	movlw .216
	movwf punter_sat_nivells
	call punter_pag3
	
	banksel valor_sat_nivells
	movfw id41
	;movfw senyal4
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
	
	banksel valor_sat_nivells
	movfw id42
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
;ja hem escrit l'ID del satelit, ara "dibuixarem" la barra
;Codi per el Satelit 1
banksel senyal1
	movfw senyal4
	xorlw 0x37
	btfsc STATUS,Z
	goto n4_7
	movfw senyal4
	xorlw 0x36
	btfsc STATUS,Z
	goto n4_6
	movfw senyal4
	xorlw 0x35
	btfsc STATUS,Z
	goto n4_5
	movfw senyal4
	xorlw 0x34
	btfsc STATUS,Z
	goto n2_4
	movfw senyal4
	xorlw 0x33
	btfsc STATUS,Z
	goto n4_3
	movfw senyal4
	xorlw 0x32
	btfsc STATUS,Z
	goto n4_2
	movfw senyal4
	xorlw 0x31
	btfsc STATUS,Z
	goto n4_1
	goto seguent_satelit5

n4_7 	
	banksel punter_sat_nivells
	movlw .7
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n4_6 	
	banksel punter_sat_nivells
	movlw .37
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n4_5 	
	banksel punter_sat_nivells
	movlw .67
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n4_4 	
	banksel punter_sat_nivells
	movlw .97
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n4_3 	
	banksel punter_sat_nivells
	movlw .127
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n4_2 	
	banksel punter_sat_nivells
	movlw .157
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n4_1 	
	banksel punter_sat_nivells
	movlw .187
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol

seguent_satelit5
	banksel punter_sat_nivells
	movlw .218
	movwf punter_sat_nivells
	call punter_pag3
	
	banksel valor_sat_nivells
	movfw id51
	;movfw senyal5
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
	
	banksel valor_sat_nivells
	movfw id52
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
	;ja hem escrit l'ID del satelit, ara "dibuixarem" la barra
	;Codi per el Satelit 1
banksel senyal1
	movfw senyal5
	xorlw 0x37
	btfsc STATUS,Z
	goto n5_7
	movfw senyal5
	xorlw 0x36
	btfsc STATUS,Z
	goto n5_6
	movfw senyal5
	xorlw 0x35
	btfsc STATUS,Z
	goto n5_5
	movfw senyal5
	xorlw 0x34
	btfsc STATUS,Z
	goto n5_4
	movfw senyal5
	xorlw 0x33
	btfsc STATUS,Z
	goto n5_3
	movfw senyal5
	xorlw 0x32
	btfsc STATUS,Z
	goto n5_2
	movfw senyal5
	xorlw 0x31
	btfsc STATUS,Z
	goto n5_1
	goto seguent_satelit6

n5_7 	
	banksel punter_sat_nivells
	movlw .9
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n5_6 	
	banksel punter_sat_nivells
	movlw .39
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n5_5 	
	banksel punter_sat_nivells
	movlw .69
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n5_4 	
	banksel punter_sat_nivells
	movlw .99
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n5_3 	
	banksel punter_sat_nivells
	movlw .129
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n5_2 
	banksel punter_sat_nivells	
    movlw .159
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n5_1 	
	banksel punter_sat_nivells
	movlw .189
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol

;Repetirem el codi per cada satlit6

seguent_satelit6
	banksel punter_sat_nivells
	movlw .220
	movwf punter_sat_nivells
	call punter_pag3
	
	banksel valor_sat_nivells
	movfw id61
	;movfw senyal6
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
	
	banksel valor_sat_nivells
	movfw id62
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3

banksel senyal1
	movfw senyal6
	xorlw 0x37
	btfsc STATUS,Z
	goto n6_7
	movfw senyal6
	xorlw 0x36
	btfsc STATUS,Z
	goto n6_6
	movfw senyal6
	xorlw 0x35
	btfsc STATUS,Z
	goto n6_5
	movfw senyal6
	xorlw 0x34
	btfsc STATUS,Z
	goto n6_4
	movfw senyal6
	xorlw 0x33
	btfsc STATUS,Z
	goto n6_3
	movfw senyal6
	xorlw 0x32
	btfsc STATUS,Z
	goto n6_2
	movfw senyal6
	xorlw 0x31
	btfsc STATUS,Z
	goto n6_1
	goto seguent_satelit7

n6_7 	
	banksel punter_sat_nivells
	movlw .11
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n6_6 	
	banksel punter_sat_nivells
	movlw .41
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n6_5 	
	banksel punter_sat_nivells
	movlw .71
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n6_4 	
	banksel punter_sat_nivells
	movlw .101
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n6_3 	
	banksel punter_sat_nivells
	movlw .131
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n6_2 	
	banksel punter_sat_nivells
	movlw .161
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n6_1 	
	banksel punter_sat_nivells
	movlw .191
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol

;Repetirem el codi per cada satlit7
seguent_satelit7

	banksel punter_sat_nivells
	movlw .222
	movwf punter_sat_nivells
	call punter_pag3
	
	banksel valor_sat_nivells
	movfw id71
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
	
	banksel valor_sat_nivells
	movfw id72
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
	;ja hem escrit l'ID del satelit, ara "dibuixarem" la barra
	;Codi per el Satelit 1
banksel senyal1
	movfw senyal7
	xorlw 0x37
	btfsc STATUS,Z
	goto n7_7
	movfw senyal7
	xorlw 0x36
	btfsc STATUS,Z
	goto n7_6
	movfw senyal7
	xorlw 0x35
	btfsc STATUS,Z
	goto n7_5
	movfw senyal7
	xorlw 0x34
	btfsc STATUS,Z
	goto n7_4
	movfw senyal7
	xorlw 0x33
	btfsc STATUS,Z
	goto n7_3
	movfw senyal7
	xorlw 0x32
	btfsc STATUS,Z
	goto n7_2
	movfw senyal7
	xorlw 0x31
	btfsc STATUS,Z
	goto n7_1
	goto seguent_satelit8

n7_7 	
	banksel punter_sat_nivells
	movlw .13
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n7_6 	
	banksel punter_sat_nivells
	movlw .43
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n7_5 	
	banksel punter_sat_nivells
	movlw .73
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n7_4 	
	banksel punter_sat_nivells
	movlw .103
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n7_3 	
	banksel punter_sat_nivells
	movlw .133
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n7_2 	
	banksel punter_sat_nivells
	movlw .163
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n7_1 	
	banksel punter_sat_nivells
	movlw .193
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol

;Repetirem el codi per cada satlit8
seguent_satelit8
	banksel punter_sat_nivells
	movlw .224
	movwf punter_sat_nivells
	call punter_pag3
	
	banksel valor_sat_nivells
	movfw id81
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
	
	banksel valor_sat_nivells
	movfw id82
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
	;ja hem escrit l'ID del satelit, ara "dibuixarem" la barra
	;Codi per el Satelit 1
banksel senyal1
	movfw senyal8
	xorlw 0x37
	btfsc STATUS,Z
	goto n8_7
	movfw senyal8
	xorlw 0x36
	btfsc STATUS,Z
	goto n8_6
	movfw senyal8
	xorlw 0x35
	btfsc STATUS,Z
	goto n8_5
	movfw senyal8
	xorlw 0x34
	btfsc STATUS,Z
	goto n8_4
	movfw senyal8
	xorlw 0x33
	btfsc STATUS,Z
	goto n8_3
	movfw senyal8
	xorlw 0x32
	btfsc STATUS,Z
	goto n8_2
	movfw senyal8
	xorlw 0x31
	btfsc STATUS,Z
	goto n8_1
	goto seguent_satelit9

n8_7 	
	banksel punter_sat_nivells
	movlw .15
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n8_6 	
	banksel punter_sat_nivells
	movlw .45
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n8_5 	
	banksel punter_sat_nivells
	movlw .75
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n8_4 	
	banksel punter_sat_nivells
	movlw .105
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n8_3 	
	banksel punter_sat_nivells
	movlw .135
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n8_2 	
	banksel punter_sat_nivells
	movlw .165
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n8_1 	
	banksel punter_sat_nivells
	movlw .195
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol

;Repetirem el codi per cada satlit9
seguent_satelit9
	banksel punter_sat_nivells
	movlw .226
	movwf punter_sat_nivells
	call punter_pag3
	
	banksel valor_sat_nivells
	movfw id91
	;movfw senyal9
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
	
	banksel valor_sat_nivells
	movfw id92
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3

banksel senyal1
	movfw senyal9
	xorlw 0x37
	btfsc STATUS,Z
	goto n9_7
	movfw senyal9
	xorlw 0x36
	btfsc STATUS,Z
	goto n9_6
	movfw senyal9
	xorlw 0x35
	btfsc STATUS,Z
	goto n9_5
	movfw senyal9
	xorlw 0x34
	btfsc STATUS,Z
	goto n9_4
	movfw senyal9
	xorlw 0x33
	btfsc STATUS,Z
	goto n9_3
	movfw senyal9
	xorlw 0x32
	btfsc STATUS,Z
	goto n9_2
	movfw senyal9
	xorlw 0x31
	btfsc STATUS,Z
	goto n9_1
	goto seguent_satelit10

n9_7 	
	banksel punter_sat_nivells
	movlw .17
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n9_6 	
	banksel punter_sat_nivells
	movlw .47
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n9_5 	
	banksel punter_sat_nivells
	movlw .77
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n9_4 	
	banksel punter_sat_nivells
	movlw .107
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n9_3 	
	banksel punter_sat_nivells
	movlw .137
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n9_2 	
	banksel punter_sat_nivells
	movlw .167
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n9_1 	
	banksel punter_sat_nivells
	movlw .197
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol

;Repetirem el codi per cada satlit10
seguent_satelit10

	banksel punter_sat_nivells
	movlw .228
	movwf punter_sat_nivells
	call punter_pag3
	
	banksel valor_sat_nivells
	movfw id101
	;movfw senyal10
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
	
	banksel valor_sat_nivells
	movfw id102
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3

banksel senyal1
	movfw senyal10
	xorlw 0x37
	btfsc STATUS,Z
	goto n10_7
	movfw senyal10
	xorlw 0x36
	btfsc STATUS,Z
	goto n10_6
	movfw senyal10
	xorlw 0x35
	btfsc STATUS,Z
	goto n10_5
	movfw senyal10
	xorlw 0x34
	btfsc STATUS,Z
	goto n10_4
	movfw senyal10
	xorlw 0x33
	btfsc STATUS,Z
	goto n10_3
	movfw senyal10
	xorlw 0x32
	btfsc STATUS,Z
	goto n10_2
	movfw senyal10
	xorlw 0x31
	btfsc STATUS,Z
	goto n10_1
	goto seguent_satelit11

n10_7 	
	banksel punter_sat_nivells
	movlw .19
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n10_6 	
	banksel punter_sat_nivells
	movlw .49
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n10_5 	
	banksel punter_sat_nivells
	movlw .79
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n10_4 	
	banksel punter_sat_nivells
	movlw .109
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n10_3 	
	banksel punter_sat_nivells
	movlw .139
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n10_2 	
	banksel punter_sat_nivells
	movlw .169
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n10_1 	
	banksel punter_sat_nivells
	movlw .199
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol

;Repetirem el codi per cada satlit11
seguent_satelit11

	banksel punter_sat_nivells
	movlw .230
	movwf punter_sat_nivells
	call punter_pag3
	
	banksel valor_sat_nivells
	movfw id111
	;movfw senyal11
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
	
	banksel valor_sat_nivells
	movfw id112
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3

banksel senyal1
	movfw senyal11
	xorlw 0x37
	btfsc STATUS,Z
	goto n11_7
	movfw senyal11
	xorlw 0x36
	btfsc STATUS,Z
	goto n11_6
	movfw senyal11
	xorlw 0x35
	btfsc STATUS,Z
	goto n11_5
	movfw senyal11
	xorlw 0x34
	btfsc STATUS,Z
	goto n11_4
	movfw senyal11
	xorlw 0x33
	btfsc STATUS,Z
	goto n11_3
	movfw senyal11
	xorlw 0x32
	btfsc STATUS,Z
	goto n11_2
	movfw senyal11
	xorlw 0x31
	btfsc STATUS,Z
	goto n11_1
	goto seguent_satelit12

n11_7 	
	banksel punter_sat_nivells
	movlw .21
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n11_6 	
	banksel punter_sat_nivells
	movlw .51
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n11_5 	
	banksel punter_sat_nivells
	movlw .81
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n11_4 	
	banksel punter_sat_nivells
	movlw .111
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n11_3 	
	banksel punter_sat_nivells
	movlw .141
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n11_2 	
	banksel punter_sat_nivells
	movlw .171
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n11_1 	
	banksel punter_sat_nivells
	movlw .201
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol

;Repetirem el codi per cada satlit12
seguent_satelit12
	banksel punter_sat_nivells
	movlw .232
	movwf punter_sat_nivells
	call punter_pag3
	
	banksel valor_sat_nivells
	movfw id121
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
	
	banksel valor_sat_nivells
	movfw id122
	andlw 0x0F
	iorlw 0x10
	banksel TEMP
	movwf TEMP
	banksel valor_sat_nivells
	movwf valor_sat_nivells
	call escriu_pag3
banksel senyal1
	movfw senyal12
	xorlw 0x37
	btfsc STATUS,Z
	goto n12_7
	movfw senyal12
	xorlw 0x36
	btfsc STATUS,Z
	goto n12_6
	movfw senyal12
	xorlw 0x35
	btfsc STATUS,Z
	goto n12_5
	movfw senyal12
	xorlw 0x34
	btfsc STATUS,Z
	goto n12_4
	movfw senyal12
	xorlw 0x33
	btfsc STATUS,Z
	goto n12_3
	movfw senyal12
	xorlw 0x32
	btfsc STATUS,Z
	goto n12_2
	movfw senyal12
	xorlw 0x31
	btfsc STATUS,Z
	goto n12_1
	goto torna_estat0_pag3

n12_7 	
	banksel punter_sat_nivells
	movlw .23
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n12_6 	
	banksel punter_sat_nivells
	movlw .53
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n12_5 	
	banksel punter_sat_nivells
	movlw .83
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n12_4 	
	banksel punter_sat_nivells
	movlw .113
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n12_3 	
	banksel punter_sat_nivells
	movlw .143
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n12_2 	
	banksel punter_sat_nivells
	movlw .173
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol
n12_1 	
	banksel punter_sat_nivells
	movlw .203
	movwf punter_sat_nivells
	call punter_pag3
	call escriu_simbol

goto torna_estat0_pag3

;Aquesta codi consulta a nivells_borrats si cal netejar 
;tota la pantalla, noms ho a de fer un sol cap desprs
;de canviar de pantalla o estariem borrant la pantalla
;continuament
borra_els_nivells
	banksel nivells_borrats
	movfw nivells_borrats
	xorlw .1
	btfss STATUS,Z
	goto torna_estat0_pag3
	clrf nivells_borrats
	movlw .0
	movwf punter_sat_nivells
	call punter_pag3
	call neteja_pantalla_pag3
goto torna_estat0_pag3


;Aquest tall de codi ens permet posar a 0 el comptador d'estats
;general, per tant tornarem a l'estat0
torna_estat0_pag3
	banksel estat_anterior
	clrf estat_anterior
    goto fi_pag3


;Fi de la nostra rutina d'interrupci, restaurarem els valors de context
;abans de tornar al programa principal 
fi_pag3  
;Restaurem els valors
	banksel PCLATH_TEMP
	movf PCLATH_TEMP,W
	movwf PCLATH
	swapf STATUS_TEMP,W
	
	movwf STATUS
	swapf W_TEMP,F
	swapf W_TEMP,W 	

;********************************************************************************
;**************************** FI RUTINA INTERRUPCIO *****************************
;*******************************************************************************
retfie
	
END				
; Fi del programa.
	


